<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>cachedb_couchbase Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id248490"></a>cachedb_couchbase Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Vladut-Stefan</span> <span class="surname">Paiu</span></h3><div class="affiliation"><span class="orgname">OpenSIPS Solutions<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Vladut-Stefan</span> <span class="surname">Paiu</span></h3></div></div></div><div><p class="copyright">Copyright © 2013 <a class="ulink" href="http://www.opensips-solutions.com/" target="_top">www.opensips-solutions.com</a></p></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id249290">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id249295">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id284077">1.2. Advantages</a></span></dt><dt><span class="section"><a href="#id248855">1.3. Limitations</a></span></dt><dt><span class="section"><a href="#id248877">1.4. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248883">1.4.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248895">1.4.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248924">1.5. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248930">1.5.1. <code class="varname">cachedb_url</code> (string)</a></span></dt><dt><span class="section"><a href="#id248968">1.5.2. <code class="varname">timeout</code> (int)</a></span></dt><dt><span class="section"><a href="#id293415">1.5.3. Exported Functions</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248944">Set <code class="varname">cachedb_url</code> parameter</a></dt><dt>1.2. <a href="#id248980">Set <code class="varname">timeout</code> parameter</a></dt><dt>1.3. <a href="#id293402">Use CouchBase servers </a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id249290"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249295"></a>1.1. Overview</h2></div></div></div><p>
		This module is an implementation of a cache system designed to work with a 
		Couchbase server. It uses the libcouchbase client library to connect to the
		server instance,
		It uses the Key-Value interface exported from the core.
	</p><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284077"></a>1.2. Advantages</h2></div></div></div><p>
		</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>memory costs are no longer on the server
				</em></span>
			</p></li><li><p>
				<span class="emphasis"><em>many servers can be used inside a cluster, so the memory
				is virtually unlimited</em></span>
			</p></li><li><p>
				<span class="emphasis"><em>the cache is 100% persistent. A restart
					of OpenSIPS server will not affect the DB. The CouchBase DB is also
				persistent so it can also be restarted without loss of information.</em></span>
			</p></li><li><p>
				<span class="emphasis"><em>CouchBase is an open-source project so
				it can be used to exchange data
				 with various other applicationsr</em></span>
			</p></li><li><p>
				<span class="emphasis"><em>By creating a CouchBase Cluster, multiple OpenSIPS
				instances can easily share key-value information</em></span>
			</p></li></ul></div><p>
	</p><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248855"></a>1.3. Limitations</h2></div></div></div><p>
			</p><div class="itemizedlist"><ul type="disc"><li><p>
			<span class="emphasis"><em>
		keys (in key:value pairs) may not contain spaces or control characters
		</em></span>
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248877"></a>1.4. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248883"></a>1.4.1. OpenSIPS Modules</h3></div></div></div><p>
		None.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248895"></a>1.4.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>libcouchbase &gt;= 2.0:</em></span>
			</p><p>
				libcoucbase can be downloaded from http://www.couchbase.com/develop/c/current
			</p></li></ul></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248924"></a>1.5. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248930"></a>1.5.1. <code class="varname">cachedb_url</code> (string)</h3></div></div></div><p>
			The urls of the server groups that OpenSIPS will connect to in order
			to use the from script cache_store,cache_fetch, etc operations.
			It can be set more than one time.
			The prefix part of the URL will be the identifier that will be used
			from the script.
			The format of the URL is
			couchbase[:identifier]://[username:password@]IP:Port/bucket_name
		</p><div class="example"><a name="id248944"></a><p class="title"><b>Example 1.1. Set <code class="varname">cachedb_url</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_couchbase", "cachedb_url","couchbase:group1://localhost:6379/default");
modparam("cachedb_couchbase", "cachedb_url","couchbase:cluster1://random_url:8888/my_bucket");
#Multiple hosts
modparam("cachedb_couchbase", "cachedb_url","couchbase:cluster1://random_url1:8888;random_url2:8888;random_url3:8888/my_bucket");
...
	</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248968"></a>1.5.2. <code class="varname">timeout</code> (int)</h3></div></div></div><p>
			The max duration in microseconds that a couchbase op is expected to last.
			Default is 3000000 ( 3 seconds )
		</p><div class="example"><a name="id248980"></a><p class="title"><b>Example 1.2. Set <code class="varname">timeout</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_couchbase", "timeout",5000000);
...
	</pre></div></div><br class="example-break"></div><div class="example"><a name="id293402"></a><p class="title"><b>Example 1.3. Use CouchBase servers </b></p><div class="example-contents"><pre class="programlisting">
...
cache_store("couchbase:group1","key","$ru value");
cache_fetch("couchbase:cluster1","key",$avp(10));
cache_remove("couchbase:cluster1","key");
...
	</pre></div></div><br class="example-break"><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293415"></a>1.5.3. Exported Functions</h3></div></div></div><p>The module does not export functions to be used
		in configuration script.</p></div></div></div></div></body></html>
