<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>cachedb_sql Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284024"></a>cachedb_sql Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Vladut-Stefan</span> <span class="surname">Paiu</span></h3><div class="affiliation"><span class="orgname">OpenSIPS Solutions<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Vladut-Stefan</span> <span class="surname">Paiu</span></h3></div></div></div><div><p class="copyright">Copyright © 2013 <a class="ulink" href="http://www.opensips-solutions.com/" target="_top">www.opensips-solutions.com</a></p></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id267976">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id281179">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id284076">1.2. Advantages</a></span></dt><dt><span class="section"><a href="#id249275">1.3. Limitations</a></span></dt><dt><span class="section"><a href="#id249299">1.4. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249582">1.4.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248940">1.4.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249586">1.5. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249591">1.5.1. <code class="varname">db_url</code> (string)</a></span></dt><dt><span class="section"><a href="#id248879">1.5.2. <code class="varname">db_table</code> (string)</a></span></dt><dt><span class="section"><a href="#id248909">1.5.3. <code class="varname">key_column</code> (string)</a></span></dt><dt><span class="section"><a href="#id293399">1.5.4. <code class="varname">value_column</code> (string)</a></span></dt><dt><span class="section"><a href="#id293426">1.5.5. <code class="varname">counter_column</code> (string)</a></span></dt><dt><span class="section"><a href="#id293452">1.5.6. <code class="varname">expires_column</code> (string)</a></span></dt><dt><span class="section"><a href="#id293479">1.5.7. <code class="varname">cache_clean_period</code> (int)</a></span></dt><dt><span class="section"><a href="#id293507">1.5.8. Exported Functions</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249604">Set <code class="varname">db_url</code> parameter</a></dt><dt>1.2. <a href="#id248866">Usage example </a></dt><dt>1.3. <a href="#id248892">Set <code class="varname">db_url</code> parameter</a></dt><dt>1.4. <a href="#id248920">Set <code class="varname">key_column</code> parameter</a></dt><dt>1.5. <a href="#id293410">Set <code class="varname">value_column</code> parameter</a></dt><dt>1.6. <a href="#id293436">Set <code class="varname">counter_column</code> parameter</a></dt><dt>1.7. <a href="#id293463">Set <code class="varname">expires_column</code> parameter</a></dt><dt>1.8. <a href="#id293491">Set <code class="varname">cache_clean_period</code> parameter</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id267976"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id281179"></a>1.1. Overview</h2></div></div></div><p>
		This module is an implementation of a cache system designed to work with a 
		regular SQL-based server. It uses the internal DB interface to connect
		to the back-end, and also implements the Key-Value interface exported from the core.
	</p><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284076"></a>1.2. Advantages</h2></div></div></div><p>
		</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>memory costs are no longer on the server
				</em></span>
			</p></li><li><p>
				<span class="emphasis"><em>the cache is 100% persistent. A restart
					of OpenSIPS server will not affect the DB. The DB is also
				persistent so it can also be restarted without loss of information.</em></span>
			</p></li><li><p>
				<span class="emphasis"><em>Multiple OpenSIPS instances can easily share key-value information
				via a regular SQL-based database</em></span>
			</p></li></ul></div><p>
	</p><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249275"></a>1.3. Limitations</h2></div></div></div><p>
			</p><div class="itemizedlist"><ul type="disc"><li><p>
			<span class="emphasis"><em>
				The module's counter operations ( ADD and SUB ) are currently only 
				supported by MySQL
		</em></span>
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249299"></a>1.4. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249582"></a>1.4.1. OpenSIPS Modules</h3></div></div></div><p>
		None.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248940"></a>1.4.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>none:</em></span>
			</p></li></ul></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249586"></a>1.5. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249591"></a>1.5.1. <code class="varname">db_url</code> (string)</h3></div></div></div><p>
			The url of the Database  that OpenSIPS will connect to in order
			to use the from script cache_store,cache_fetch, etc operations.
		</p><div class="example"><a name="id249604"></a><p class="title"><b>Example 1.1. Set <code class="varname">db_url</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_sql", "db_url","mysql://localhost/my_database");
...
	</pre></div></div><br class="example-break"><div class="example"><a name="id248866"></a><p class="title"><b>Example 1.2. Usage example </b></p><div class="example-contents"><pre class="programlisting">
...
cache_store("sql","key","$ru value");
cache_add("sql","counter",10);
...
	</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248879"></a>1.5.2. <code class="varname">db_table</code> (string)</h3></div></div></div><p>
			The table of the Database  that OpenSIPS will connect to in order
			to use the from script cache_store,cache_fetch, etc operations.
		</p><div class="example"><a name="id248892"></a><p class="title"><b>Example 1.3. Set <code class="varname">db_url</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_sql", "db_table","my_table");
...
	</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248909"></a>1.5.3. <code class="varname">key_column</code> (string)</h3></div></div></div><p>
			The column where the key will be stored
		</p><div class="example"><a name="id248920"></a><p class="title"><b>Example 1.4. Set <code class="varname">key_column</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_sql", "key_column","some_name");
...
	</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293399"></a>1.5.4. <code class="varname">value_column</code> (string)</h3></div></div></div><p>
			The column where the value will be stored
		</p><div class="example"><a name="id293410"></a><p class="title"><b>Example 1.5. Set <code class="varname">value_column</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_sql", "value_column","some_name");
...
	</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293426"></a>1.5.5. <code class="varname">counter_column</code> (string)</h3></div></div></div><p>
			The column where the counter value will be stored
		</p><div class="example"><a name="id293436"></a><p class="title"><b>Example 1.6. Set <code class="varname">counter_column</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_sql", "counter_column","some_name");
...
	</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293452"></a>1.5.6. <code class="varname">expires_column</code> (string)</h3></div></div></div><p>
			The column where the expires will be stored
		</p><div class="example"><a name="id293463"></a><p class="title"><b>Example 1.7. Set <code class="varname">expires_column</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_sql", "expires_column","some_name");
...
	</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293479"></a>1.5.7. <code class="varname">cache_clean_period</code> (int)</h3></div></div></div><p>
			The interval in seconds at which the expired keys will be removed from
			the database. Default value is 60 ( seconds )
		</p><div class="example"><a name="id293491"></a><p class="title"><b>Example 1.8. Set <code class="varname">cache_clean_period</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_sql", "cache_clean_period",10);
...
	</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293507"></a>1.5.8. Exported Functions</h3></div></div></div><p>The module does not export functions to be used
		in configuration script.</p></div></div></div></div></body></html>
