<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Flatstore Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id248490"></a>Flatstore Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Jan</span> <span class="surname">Janak</span></h3><div class="affiliation"><span class="orgname">FhG FOKUS<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Jan</span> <span class="surname">Janak</span></h3></div></div></div><div><p class="copyright">Copyright © 2004, 2005 FhG FOKUS</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date: 2013-01-29 13:35:11 +0100 (Tue, 29 Jan 2013) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id281315">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id284081">1.1. Overview</a></span></dt><dd><dl><dt><span class="section"><a href="#rotating">1.1.1. Rotating Log Files</a></span></dt></dl></dd><dt><span class="section"><a href="#id249624">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249629">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248927">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248952">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248958">1.3.1. <code class="varname">flush</code> (integer)</a></span></dt><dt><span class="section"><a href="#id293504">1.3.2. <code class="varname">delimiter</code> (char)</a></span></dt><dt><span class="section"><a href="#id293537">1.3.3. <code class="varname">suffix</code> (string)</a></span></dt><dt><span class="section"><a href="#id293570">1.3.4. <code class="varname">prefix</code> (string)</a></span></dt><dt><span class="section"><a href="#id293603">1.3.5. <code class="varname">single_file</code> (integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293637">1.4. Exported Functions</a></span></dt><dt><span class="section"><a href="#id293646">1.5. Exported MI Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293652">1.5.1. 
		<code class="function">flat_rotate</code>
		</a></span></dt></dl></dd></dl></dd><dt><span class="chapter"><a href="#id294153">2. Developer Guide</a></span></dt></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248976">Set &#8220;<span class="quote">flush</span>&#8221; parameter</a></dt><dt>1.2. <a href="#id293521">Set &#8220;<span class="quote">delimiter</span>&#8221; parameter</a></dt><dt>1.3. <a href="#id293554">Set &#8220;<span class="quote">suffix</span>&#8221; parameter</a></dt><dt>1.4. <a href="#id293587">Set &#8220;<span class="quote">prefix</span>&#8221; parameter</a></dt><dt>1.5. <a href="#id293620">Set &#8220;<span class="quote">single_file</span>&#8221; parameter</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id281315"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284081"></a>1.1. Overview</h2></div></div></div><p>
		Flatstore is one of so-called OpenSIPS database modules. It does not
		export any functions executable from the configuration scripts, but
		it exports a subset of functions from the database API and thus
		other module can use it instead of, for example, mysql module.
	</p><p>
		The module does not export all functions of the database API, it
		supports only one function, insert. The module is limited but very
		fast. It is especially suitable for storing accounting information
		on sites with extremely high traffic. If MySQL is too slow or if
		you get a huge amount of accounting data then you can consider
		using this module. Note that the acc module is the only module that
		was tested with flastore.
	</p><p>
		The format of the files produced by this module is plain text. Each
		line consists of several fields, fields are separated by default by
		the | character. New information is always appended at the end of the
		file, searching, deleting and updating of existing data is not
		supported by the module.
	</p><p>
		The acc module can be configured to use flatstore module as
		database backend using the db_url_parameter:
	</p><pre class="programlisting">
modparam("acc", "db_url", "flatstore:/var/log/acc")
</pre><p>
		This configuration options tells acc module that it should use the
		flatstore module and the flatstore module should create all files
		in /var/log/acc directory. The directory must exist and OpenSIPS
		processes must have permissions to create files in that directory.
	</p><p>
		Name of files in that directory will follow the following pattern:
	</p><pre class="programlisting">
&lt;prefix&gt;&lt;table_name&gt;[_&lt;process_name&gt;]&lt;suffix&gt;
</pre><p>
		For example, without setting any module parameter, the
		entries writen by OpenSIPS process 8 into acc table would
		be written in file acc_8.log. For each table there will be several
		files, one file for every OpenSIPS process that wrote some data into
		that table. The main reason why there are several files for each
		table is that it is much faster to have one file per process,
		because it does not require any locking and thus OpenSIPS processes will
		not block each other. To get the complete data for a table you can
		simply concatenate the contents of files with the same table name
		but different process id. Alternatively, you can use the single_file
		parameter, and all processes will dump the data into the same file. Note
		that this will induce some latency.
	</p><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="rotating"></a>1.1.1. Rotating Log Files</h3></div></div></div><p>
		There is a new OpenSIPS MI (management interface) command called 
		flat_rotate.
		When OpenSIPS receives the command then it will close and reopen all
		files used by flatstore module. The rotation itself has to be
		done by another application (such as logrotate). Follow these
		steps to rotate files generated by flatstore module:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
			Rename the files that you want to rotate:
			</p><pre class="screen">
cd /var/log/acc
mv acc_1.log acc_1.log.20050605
mv acc_2.log acc_2.log.20050605
mv acc_4.log acc_3.log.20050605
...
			</pre><p>
			Note that at this point OpenSIPS will still be writing all
			data into the renamed files.
			</p></li><li><p>
			Send OpenSIPS the MI command to close and reopen the
			renamed files. For example, using FIFO:
			</p><pre class="screen">
opensipsctl fifo flat_rotate
			</pre><p>
			This will force OpenSIPS to close the renamed files and open
			new ones with original names, such as
			<code class="filename">acc_1.log</code>. New files will be open
			at the point when OpenSIPS has some data to write. It is
			normal that the files will be not created immediately
			if there is no traffic on the proxy server.
			</p><p>
			Note that the suffix and prefix parameters are re-evaluated
			each time the flat_rotate command is issued. Therefore, after
			a rotate command, it is possible to open a different file than
			previous one.
			</p></li><li><p>
			Move the renamed files somewhere else and process them.
			</p></li></ul></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249624"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249629"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following  modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>No dependencies on other OpenSIPS modules</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248927"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248952"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248958"></a>1.3.1. <code class="varname">flush</code> (integer)</h3></div></div></div><p>
		Enable or disable flushing after each write.
		</p><p>
		<span class="emphasis"><em>
			Default value is 1.
		</em></span>
		</p><div class="example"><a name="id248976"></a><p class="title"><b>Example 1.1. Set &#8220;<span class="quote">flush</span>&#8221; parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("db_flatstore", "flush", 0)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293504"></a>1.3.2. <code class="varname">delimiter</code> (char)</h3></div></div></div><p>
		Delimiter used to separate the values.
		</p><p>
		<span class="emphasis"><em>
			Default value is '|'.
		</em></span>
		</p><div class="example"><a name="id293521"></a><p class="title"><b>Example 1.2. Set &#8220;<span class="quote">delimiter</span>&#8221; parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("db_flatstore", "delimiter", ";")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293537"></a>1.3.3. <code class="varname">suffix</code> (string)</h3></div></div></div><p>
		The suffix appended to the table name. Can be a pseudo
		variable.
		</p><p>
		<span class="emphasis"><em>
			Default value is ".log".
		</em></span>
		</p><div class="example"><a name="id293554"></a><p class="title"><b>Example 1.3. Set &#8220;<span class="quote">suffix</span>&#8221; parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("db_flatstore", "suffix", "$time(%H)")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293570"></a>1.3.4. <code class="varname">prefix</code> (string)</h3></div></div></div><p>
		The table name prefix. Can be a pseudo variable.
		</p><p>
		<span class="emphasis"><em>
			Defaul value is none.
		</em></span>
		</p><div class="example"><a name="id293587"></a><p class="title"><b>Example 1.4. Set &#8220;<span class="quote">prefix</span>&#8221; parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("db_flatstore", "prefix", "$time(%H)")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293603"></a>1.3.5. <code class="varname">single_file</code> (integer)</h3></div></div></div><p>
		Specifies if all the processes should dump the data
		into a single file.
		</p><p>
		<span class="emphasis"><em>
			Default value is 0.
		</em></span>
		</p><div class="example"><a name="id293620"></a><p class="title"><b>Example 1.5. Set &#8220;<span class="quote">single_file</span>&#8221; parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("db_flatstore", "single_file", 1)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293637"></a>1.4. Exported Functions</h2></div></div></div><p>
	There are no function exported to routing script.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293646"></a>1.5. Exported MI Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293652"></a>1.5.1. 
		<code class="function">flat_rotate</code>
		</h3></div></div></div><p>
		It changes the name of the files where it is written.
		</p><p>
		Name: <span class="emphasis"><em>flat_rotate</em></span>
		</p><p>Parameters: <span class="emphasis"><em>none</em></span></p><p>
		MI FIFO Command Format:
		</p><pre class="programlisting">
		:flat_rotate:_reply_fifo_file_
		_empty_line_
		</pre></div></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id294153"></a>Chapter 2. Developer Guide</h2></div></div></div><p>
	The module implements the DB <acronym class="acronym">API</acronym>.
	</p></div></div></body></html>
