<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Diversion Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284028"></a>Diversion Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Jan</span> <span class="surname">Janak</span></h3><div class="affiliation"><span class="orgname">FhG FOKUS<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Jan</span> <span class="surname">Janak</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Saul</span> <span class="surname">Ibarra Corretge</span></h3></div></div></div><div><p class="copyright">Copyright © 2004 FhG FOKUS</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 9064 $</td><td align="left">$Date: 2013-01-29 13:35:11 +0100 (Tue, 29 Jan 2013) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id284080">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id284084">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248018">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248024">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249270">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249295">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249300">1.3.1. <code class="varname">suffix</code> (string)</a></span></dt></dl></dd><dt><span class="section"><a href="#id249617">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id249623">1.4.1. <code class="function">add_diversion(reason [[,uri], counter])</code></a></span></dt></dl></dd><dt><span class="section"><a href="#id248967">1.5. Diversion Example</a></span></dt></dl></dd><dt><span class="chapter"><a href="#id248437">2. Developer Guide</a></span></dt></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249602"><code class="varname">suffix</code> usage</a></dt><dt>1.2. <a href="#id248948"><code class="function">add_diversion</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id284080"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284084"></a>1.1. Overview</h2></div></div></div><p>
		The module implements the Diversion extensions as per 
		draft-levy-sip-diversion-08.  The
		diversion extensions are useful in various scenarios involving call
		forwarding. Typically one needs to communicate the original recipient 
		of the call to the PSTN gateway and this is what the diversion 
		extensions can be used for.
	</p><div class="warning" style="margin-left: 0.5in; margin-right: 0.5in;"><h3 class="title">Warning</h3><p>
		The draft-levy-sip-diversion-08 is expired!! See
		<a class="ulink" href="https://datatracker.ietf.org/public/idindex.cgi?command=id_detail%E2%88%A7id=6002" target="_top"> IETF I-D tracker</a>.
	</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248018"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248024"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>None.</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249270"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249295"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249300"></a>1.3.1. <code class="varname">suffix</code> (string)</h3></div></div></div><p>
		The suffix to be appended to the end of the header field. You can use 
		the parameter to specify additional parameters to be added to the 
		header field, see the example.
		</p><p>
		Default value is &#8220;<span class="quote"></span>&#8221; (empty string).
		</p><div class="example"><a name="id249602"></a><p class="title"><b>Example 1.1. <code class="varname">suffix</code> usage</b></p><div class="example-contents"><pre class="programlisting">
modparam("diversion", "suffix", ";privacy=full")
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249617"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249623"></a>1.4.1. <code class="function">add_diversion(reason [[,uri], counter])</code></h3></div></div></div><p>
		The function adds a new diversion header field before any other 
		existing Diversion header field in the message (the newly added 
		Diversion header field will become the topmost Diversion header field).
		The inbound (without any modifications done by the
		proxy server) Request-URI will be used as the Diversion URI.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>reason</em></span> - The reason string to be added 
			as the reason parameter
			</p></li><li><p><span class="emphasis"><em>uri</em></span> - The URI to be added in the header. If missing
			    the unchanged RURI from the original message will be used.
			</p></li><li><p><span class="emphasis"><em>counter</em></span> - Diversion counter to be added to the header,
			    as defined by the standard.
			</p></li></ul></div><p>
	This function can be used from REQUEST_ROUTE, FAILURE_ROUTE.
	</p><div class="example"><a name="id248948"></a><p class="title"><b>Example 1.2. <code class="function">add_diversion</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
add_diversion("user-busy");
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248967"></a>1.5. Diversion Example</h2></div></div></div><p>
			The following example shows a Diversion header field added to 
			INVITE message. The original INVITE received by the user agent 
			of sip:bob@sip.org is:
		</p><pre class="programlisting">
INVITE sip:bob@sip.org SIP/2.0
Via: SIP/2.0/UDP 1.2.3.4:5060
From: "mark" &lt;sip:mark@sip.org&gt;;tag=ldgheoihege
To: "Bob" &lt;sip:bob@sip.org&gt;
Call-ID: adgasdkgjhkjha@1.2.3.4
CSeq: 3 INVITE
Contact: &lt;sip:mark@1.2.3.4&gt;
Content-Length: 0
</pre><p>
			The INVITE message is diverted by the user agent 
			of sip:bob@sip.org because the user was talking to someone else 
			and the new destination is sip:alice@sip.org :
		</p><pre class="programlisting">
INVITE sip:alice@sip.org SIP/2.0
Via: SIP/2.0/UDP 5.6.7.8:5060
Via: SIP/2.0/UDP 1.2.3.4:5060
From: "mark" &lt;sip:mark@sip.org&gt;;tag=ldgheoihege
To: "Bob" &lt;sip:bob@sip.org&gt;
Call-ID: adgasdkgjhkjha@1.2.3.4
CSeq: 3 INVITE
Diversion: &lt;sip:bob@sip.org&gt;;reason=user-busy
Contact: &lt;sip:mark@1.2.3.4&gt;
Content-Length: 0
</pre></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id248437"></a>Chapter 2. Developer Guide</h2></div></div></div><p>
	According to the specification new Diversion header field should be inserted as the topmost
	Diversion header field in the message, that means before any other existing Diversion header
	field in the message. In addition to that, <code class="function">add_diversion</code> function can be called several times and each time
	it should insert the new Diversion header field as the topmost one.
    </p><p>
	In order to implement this, add_diversion function creates the anchor in data_lump lists as
	a static variable to ensure that the next call of the function will use the same anchor and
	would insert new Diversion headers before the one created in the previous execution. To my
	knowledge this is the only way of inserting the diversion header field before any other
	created in previous runs of the function.
    </p><p>
	The anchor kept this way is only valid for a single message and we have to invalidate it
	when another message is being processed. For this reason, the function also stores the id of
	the message in another static variable and compares the value of that variable with the id
	of the SIP message being processed. If they differ then the anchor will be invalidated and
	the function creates a new one.
    </p><p>
	The following code snippet shows the code that invalidates the anchor, new anchor will be
	created when the <code class="varname">anchor</code> variable is set to 0.
    </p><pre class="programlisting">
static inline int add_diversion_helper(struct sip_msg* msg, str* s)
{
    static struct lump* anchor = 0;
    static int msg_id = 0;

    if (msg_id != msg-&gt;id) {
        msg_id = msg-&gt;id;
        anchor = 0;
    }
...
}
</pre></div></div></body></html>
