<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>event_rabbitmq Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id248805"></a>event_rabbitmq Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Razvan</span> <span class="surname">Crainea</span></h3><div class="affiliation"><span class="orgname">OpenSIPS Solutions<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Razvan</span> <span class="surname">Crainea</span></h3></div></div></div><div><p class="copyright">Copyright © 2011 <a class="ulink" href="http://www.opensips-solutions.com/" target="_top">www.opensips-solutions.com</a></p></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id280448">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id267015">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248010">1.2. RabbitMQ events syntax</a></span></dt><dt><span class="section"><a href="#id249342">1.3. RabbitMQ socket syntax</a></span></dt><dt><span class="section"><a href="#id248395">1.4. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248401">1.4.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248412">1.4.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248437">1.5. Exported Parameters</a></span></dt><dt><span class="section"><a href="#id293407">1.6. Exported Functions</a></span></dt><dt><span class="section"><a href="#id293417">1.7. Example</a></span></dt><dt><span class="section"><a href="#id293451">1.8. Installation and Running</a></span></dt><dd><dl><dt><span class="section"><a href="#id293456">1.8.1. OpenSIPS config file</a></span></dt></dl></dd></dl></dd><dt><span class="chapter"><a href="#id293909">2. Frequently Asked Questions</a></span></dt></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id293426">E_PIKE_BLOCKED event</a></dt><dt>1.2. <a href="#id293437">RabbitMQ socket</a></dt><dt>1.3. <a href="#id293464">OpenSIPS config script - sample event_rabbitmq usage</a></dt><dt>2.1. <a href="#id294004">Event subscription</a></dt><dt>2.2. <a href="#id294022">Event subscription</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id280448"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id267015"></a>1.1. Overview</h2></div></div></div><p>
		<span class="emphasis"><em>RabbitMQ</em></span>
		(<a class="ulink" href="http://www.rabbitmq.com/" target="_top">http://www.rabbitmq.com/</a>) 
		is an open source messaging server. It's purpose is to
		manage received messages in queues, taking advantage of
		the flexible AMQP protocol.
	</p><p>
		This module provides the implementation of a RabbitMQ client for the
		Event Interface. It is used to send AMQP messages to a RabbitMQ server
		each time the Event Interface triggers an event subscribed for.
	</p><p>
		The AMQP protocol is only used as the transport layer for notifications.
		The content of a message is presented in the next section.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248010"></a>1.2. RabbitMQ events syntax</h2></div></div></div><p>
		The raised events will follow the following grammar:
		</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>
			event = event_name (argument '\n')*
			</em></span></p></li><li><p><span class="emphasis"><em>
			event_name = non-quoted_string'\n'
			</em></span></p></li><li><p><span class="emphasis"><em>
			argument = ((arg_name '::')? arg_value)? | (arg_value)
			</em></span></p></li><li><p><span class="emphasis"><em>
			arg_name = not-quoted_string
			</em></span></p></li><li><p><span class="emphasis"><em>
			arg_value = not-quoted_string | '"' string '"'
			</em></span></p></li><li><p><span class="emphasis"><em>
			not-quoted_string = string - {',",\n,\r}
			</em></span></p></li></ul></div><p>
	</p><p>The event name can contain any non-quoted string character, but
		it is recommended to follow the syntax:
		E_<span class="emphasis"><em>MODULE_NAME</em></span>_<span class="emphasis"><em>EXTRA_NAME</em></span>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249342"></a>1.3. RabbitMQ socket syntax</h2></div></div></div><p>
		</p><p><span class="emphasis"><em>'rabbitmq:' [user[':'password] '@' host [':' port] '/' exchange</em></span></p><p>
	</p><p>
		Meanings:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
					<span class="emphasis"><em>'rabbitmq:'</em></span> - informs the Event Interface that the
					events sent to this subscriber should be handled by the
					<span class="emphasis"><em>event_rabbitmq</em></span> module.
			</p></li><li><p>
					<span class="emphasis"><em>user</em></span> - username used for RabbitMQ server
					authentication. The default value is 'guest'.
			</p></li><li><p>
					<span class="emphasis"><em>password</em></span> - password used for RabbitMQ server
					authentication. The default value is 'guest'.
			</p></li><li><p>
					<span class="emphasis"><em>host</em></span> - host name of the RabbitMQ server.
			</p></li><li><p>
					<span class="emphasis"><em>port</em></span> - port of the RabbitMQ server. The
					default value is '5672'.
			</p></li><li><p>
					<span class="emphasis"><em>exchange</em></span> - this is the exchange routing 
					information used by the AMQP protocol. It is also used to
					identify the queue where the event should be sent.
					</p><p>NOTE: if the queue does not exist, this module will not 
						try to create it.</p><p>
			</p></li></ul></div><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248395"></a>1.4. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248401"></a>1.4.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>No dependencies on other OpenSIPS modules</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248412"></a>1.4.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before 
		running OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>librabbitmq-dev</em></span>
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248437"></a>1.5. Exported Parameters</h2></div></div></div><p>
		No parameter exported by this module.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293407"></a>1.6. Exported Functions</h2></div></div></div><p>
		No function exported to be used from configuration file.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293417"></a>1.7. Example</h2></div></div></div><p>
			This is an example of an event raised by the pike module
			when it decides an ip should be blocked:
		</p><div class="example"><a name="id293426"></a><p class="title"><b>Example 1.1. E_PIKE_BLOCKED event</b></p><div class="example-contents"><pre class="programlisting">

	E_PIKE_BLOCKED
	ip::192.168.2.11

</pre></div></div><br class="example-break"><div class="example"><a name="id293437"></a><p class="title"><b>Example 1.2. RabbitMQ socket</b></p><div class="example-contents"><pre class="programlisting">

	rabbitmq:guest:guest@127.0.0.1:5672/pike

	# same socket can be written as
	rabbitmq:127.0.0.1/pike

</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293451"></a>1.8. Installation and Running</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293456"></a>1.8.1. OpenSIPS config file</h3></div></div></div><p>
			This configuration file presents the usage of the event_rabbitmq
			module. In this scenario, a message is sent to a RabbitMQ server
			everytime OpenSIPS receives a MESSAGE request. The parameters 
			passed to the server are the R-URI username and the message
			body.
		</p><div class="example"><a name="id293464"></a><p class="title"><b>Example 1.3. OpenSIPS config script - sample event_rabbitmq usage</b></p><div class="example-contents"><pre class="programlisting">
...
loadmodule "signaling.so"
loadmodule "sl.so"
loadmodule "tm.so"
loadmodule "rr.so"
loadmodule "maxfwd.so"
loadmodule "usrloc.so"
loadmodule "registrar.so"
loadmodule "textops.so"
loadmodule "uri.so"
loadmodule "acc.so"
loadmodule "event_rabbitmq.so"

startup_route {
	if (!subscribe_event("E_SIP_MESSAGE", "rabbitmq:127.0.0.1/sipmsg")) {
		xlog("L_ERR","cannot the RabbitMQ server to the E_SIP_MESSAGE event\n");
	}
}

route{

	if (!mf_process_maxfwd_header("10")) {
		sl_send_reply("483","Too Many Hops");
		exit;
	}

	if (has_totag()) {
		if (loose_route()) {
			if (is_method("INVITE")) {
				record_route();
			}
			route(1);
		} else {
			if ( is_method("ACK") ) {
				if ( t_check_trans() ) {
					t_relay();
					exit;
				} else {
					exit;
				}
			}
			sl_send_reply("404","Not here");
		}
		exit;
	}

	if (is_method("CANCEL"))
	{
		if (t_check_trans())
			t_relay();
		exit;
	}

	t_check_trans();

	if (loose_route()) {
		xlog("L_ERR",
		"Attempt to route with preloaded Route's [$fu/$tu/$ru/$ci]");
		if (!is_method("ACK"))
			sl_send_reply("403","Preload Route denied");
		exit;
	}

	if (!is_method("REGISTER|MESSAGE"))
		record_route();

	if (!uri==myself)
	{
		append_hf("P-hint: outbound\r\n"); 
		route(1);
	}

	if (is_method("PUBLISH"))
	{
		sl_send_reply("503", "Service Unavailable");
		exit;
	}
	

	if (is_method("REGISTER"))
	{
		if (!save("location"))
			sl_reply_error();

		exit;
	}

	if ($rU==NULL) {
		sl_send_reply("484","Address Incomplete");
		exit;
	}

	if (is_method("MESSAGE")) {
		$avp(attrs) = "user";
		$avp(vals) = $rU;
		$avp(attrs) = "msg";
		$avp(vals) = $rb;
		if (!raise_event("E_SIP_MESSAGE", $avp(attrs), $avp(vals)))
			xlog("L_ERR", "cannot raise E_SIP_MESSAGE event\n");
	}

	if (!lookup("location","m")) {
		switch ($retcode) {
			case -1:
			case -3:
				t_newtran();
				t_reply("404", "Not Found");
				exit;
			case -2:
				sl_send_reply("405", "Method Not Allowed");
				exit;
		}
	}

	route(1);
}


route[1] {
	if (is_method("INVITE")) {
		t_on_failure("1");
	}

	if (!t_relay()) {
		sl_reply_error();
	};
	exit;
}


failure_route[1] {
	if (t_was_cancelled()) {
		exit;
	}
}

...
</pre></div></div><br class="example-break"></div></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id293909"></a>Chapter 2. Frequently Asked Questions</h2></div></div></div><div class="qandaset"><table border="0" summary="Q and A Set"><col align="left" width="1%"><tbody><tr class="question"><td align="left" valign="top"><a name="id293598"></a><a name="id293600"></a><p><b>2.1.</b></p></td><td align="left" valign="top"><p>What is the maximum lenght of a AMQP message?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			The maximum length of a datagram event is 16384 bytes.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id293920"></a><a name="id293922"></a><p><b>2.2.</b></p></td><td align="left" valign="top"><p>Where can I find more about OpenSIPS?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			Take a look at <a class="ulink" href="http://www.opensips.org/" target="_top">http://www.opensips.org/</a>.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id293948"></a><a name="id293950"></a><p><b>2.3.</b></p></td><td align="left" valign="top"><p>What is the vhost used by the AMQP server?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			Currently, the only vhost supported is <span class="emphasis"><em>'/'</em></span>.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id293966"></a><a name="id293968"></a><p><b>2.4.</b></p></td><td align="left" valign="top"><p>How can I set a vhost in the socket?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
				This version doesn't support a different vhost.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id293982"></a><a name="id293984"></a><p><b>2.5.</b></p></td><td align="left" valign="top"><p>How can I send an event to my RabbitMQ server?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
				This module acts as a transport module for the OpenSIPS
				Event Interface. Therefore, this module should follow the
				Event Interface behavior:
			</p><p>
				The first step is to subscribe the RabbitMQ server to
				the OpenSIPS Event Interface. This can be done using the
				<span class="emphasis"><em>subscribe_event</em></span> core function:
			</p><div class="example"><a name="id294004"></a><p class="title"><b>Example 2.1. Event subscription</b></p><div class="example-contents"><pre class="programlisting">
startup_route {
	subscribe_event("E_RABBITMQ_EVENT", "rabbitmq:127.0.0.1/queue");
}
		</pre></div></div><br class="example-break"><p>
				The next step is to raise the event from the script,
				using the <span class="emphasis"><em>raise_event</em></span> core function:
			</p><div class="example"><a name="id294022"></a><p class="title"><b>Example 2.2. Event subscription</b></p><div class="example-contents"><pre class="programlisting">
route {
	...
	/* decided that an event should be raised */
	raise_event("E_RABBITMQ_EVENT");
	...
}
		</pre></div></div><br class="example-break"><p>
				NOTE that the event used above is only to exemplify the
				usage from the script. Any event published through the
				OpenSIPS Event Interface can be raised using this module.
			</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id294042"></a><a name="id294044"></a><p><b>2.6.</b></p></td><td align="left" valign="top"><p>Where can I find more information about RabbitMQ?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			You can find more information about RabbitMQ  on
			their official website
			(<a class="ulink" href="http://www.rabbitmq.com/" target="_top">
				http://www.rabbitmq.com/</a>).
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id294063"></a><a name="id294065"></a><p><b>2.7.</b></p></td><td align="left" valign="top"><p>Where can I post a question about this module?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			First at all check if your question was already answered on one of
			our mailing lists: 
		</p><div class="itemizedlist"><ul type="disc"><li><p>User Mailing List - <a class="ulink" href="http://lists.opensips.org/cgi-bin/mailman/listinfo/users" target="_top">http://lists.opensips.org/cgi-bin/mailman/listinfo/users</a></p></li><li><p>Developer Mailing List - <a class="ulink" href="http://lists.opensips.org/cgi-bin/mailman/listinfo/devel" target="_top">http://lists.opensips.org/cgi-bin/mailman/listinfo/devel</a></p></li></ul></div><p>
			E-mails regarding any stable OpenSIPS release should be sent to 
			<code class="email">&lt;<a class="email" href="mailto:users@lists.opensips.org">users@lists.opensips.org</a>&gt;</code> and e-mails regarding development versions
			should be sent to <code class="email">&lt;<a class="email" href="mailto:devel@lists.opensips.org">devel@lists.opensips.org</a>&gt;</code>.
		</p><p>
			If you want to keep the mail private, send it to 
			<code class="email">&lt;<a class="email" href="mailto:users@lists.opensips.org">users@lists.opensips.org</a>&gt;</code>.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id294124"></a><a name="id294126"></a><p><b>2.8.</b></p></td><td align="left" valign="top"><p>How can I report a bug?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			Please follow the guidelines provided at:
			<a class="ulink" href="https://github.com/OpenSIPS/opensips/issues" target="_top">https://github.com/OpenSIPS/opensips/issues</a>.
		</p></td></tr></tbody></table></div></div></div></body></html>
