<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>exec Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284027"></a>exec Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Jiri</span> <span class="surname">Kuthan</span></h3><div class="affiliation"><span class="orgname">FhG FOKUS<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Jan</span> <span class="surname">Janak</span></h3></div></div></div><div><p class="copyright">Copyright © 2003 FhG FOKUS</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date: 2013-01-29 13:35:11 +0100 (Tue, 29 Jan 2013) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id275643">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id275329">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id249587">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249592">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249615">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249640">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248895">1.3.1. <code class="varname">setvars</code> (integer)</a></span></dt><dt><span class="section"><a href="#id248934">1.3.2. 
			<code class="varname">time_to_kill</code> (integer)
		</a></span></dt><dt><span class="section"><a href="#id293408">1.3.3. <code class="varname">async</code> (integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293444">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293449">1.4.1. 
		<code class="function">exec_dset(command)</code>
		</a></span></dt><dt><span class="section"><a href="#id293510">1.4.2. 
		<code class="function">exec_msg(command)</code>
		</a></span></dt><dt><span class="section"><a href="#id293569">1.4.3. 
		<code class="function">exec_avp(command [, avplist])</code>
		</a></span></dt><dt><span class="section"><a href="#id293633">1.4.4. 
		<code class="function">exec_getenv(environment_variable [, avp])</code>
		</a></span></dt></dl></dd><dt><span class="section"><a href="#id293699">1.5. Known Issues</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248913">Set &#8220;<span class="quote">setvars</span>&#8221; parameter</a></dt><dt>1.2. <a href="#id248954">Set &#8220;<span class="quote">time_to_kill</span>&#8221; parameter</a></dt><dt>1.3. <a href="#id293427">Set &#8220;<span class="quote">async</span>&#8221; parameter</a></dt><dt>1.4. <a href="#id293492"><code class="function">exec_dset</code> usage</a></dt><dt>1.5. <a href="#id293552"><code class="function">exec_msg</code> usage</a></dt><dt>1.6. <a href="#id293616"><code class="function">exec_avp</code> usage</a></dt><dt>1.7. <a href="#id293681"><code class="function">exec_getenv</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id275643"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id275329"></a>1.1. Overview</h2></div></div></div><p>
		Exec module allows to start an external command from a OpenSIPS script. 
		The commands may be any valid shell commands--the command string is 
		passed to shell using &#8220;<span class="quote">popen</span>&#8221; command. OpenSIPS passes 
		additionally lot of information about request in environment
		variables:
	</p><div class="itemizedlist"><ul type="disc"><li><p>
			SIP_HF_&lt;hf_name&gt; contains value of each header field in 
			request. If a header field occurred multiple times, values are 
			concatenated and comma-separated. &lt;hf_name&gt; is in capital 
			letters. Ff a header-field name occurred in compact form, 
			&lt;hf_name&gt; is canonical.
		</p></li><li><p>
			SIP_TID is transaction identifier. All request retransmissions or 
			CANCELs/ACKs associated with a previous INVITE result in the same 
			value.
		</p></li><li><p>
			SIP_DID is dialog identifier, which is the same as to-tag. 
			Initially, it is empty.
		</p></li><li><p>
			SIP_SRCIP is source <acronym class="acronym">IP</acronym> address from which request came.
		</p></li><li><p>
			SIP_ORURI is original request <acronym class="acronym">URI</acronym>.
		</p></li><li><p>
			SIP_RURI is <span class="emphasis"><em>current</em></span> request <acronym class="acronym">URI</acronym> (if 
			unchanged, equal to original).
		</p></li><li><p>
			SIP_USER is userpart of <span class="emphasis"><em>current</em></span> request <acronym class="acronym">URI</acronym>.
		</p></li><li><p>
			SIP_OUSER is userpart of original request <acronym class="acronym">URI</acronym>.
		</p></li></ul></div><p>
		NOTE: The envirnment variables must be specified with double $
		(e.g., $$SIP_OUSER) in the parameters given to exec functions.
		Otherwise they will be evaluated as OpenSIPS pseudo-variables,
		throwing errors.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249587"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249592"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following  modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>No dependencies on other OpenSIPS modules</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249615"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249640"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248895"></a>1.3.1. <code class="varname">setvars</code> (integer)</h3></div></div></div><p>
		Turn off to disable setting environment variables for executed commands.
		</p><p>
		<span class="emphasis"><em>
			Default value is 1.
		</em></span>
		</p><div class="example"><a name="id248913"></a><p class="title"><b>Example 1.1. Set &#8220;<span class="quote">setvars</span>&#8221; parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("exec", "setvars", 1)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248934"></a>1.3.2. 
			<code class="varname">time_to_kill</code> (integer)
		</h3></div></div></div><p>
		Specifies the longest time a program is allowed to execute. If the 
		time is exceeded, the program is killed.
		</p><p>
		<span class="emphasis"><em>
			Default value is 0.
		</em></span>
		</p><div class="example"><a name="id248954"></a><p class="title"><b>Example 1.2. Set &#8220;<span class="quote">time_to_kill</span>&#8221; parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("exec", "time_to_kill", 20)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293408"></a>1.3.3. <code class="varname">async</code> (integer)</h3></div></div></div><p>
		Turns on the asynchronous mode for 'exec_msg' function. All commands
		will be executed by a different process and the caller will continue
		it's flow, without waiting for a response.
		</p><p>
		<span class="emphasis"><em>
			Default value is 0.
		</em></span>
		</p><div class="example"><a name="id293427"></a><p class="title"><b>Example 1.3. Set &#8220;<span class="quote">async</span>&#8221; parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("exec", "async", 1)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293444"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293449"></a>1.4.1. 
		<code class="function">exec_dset(command)</code>
		</h3></div></div></div><p>
		Executes an external command. Current <acronym class="acronym">URI</acronym> is passed to the command 
		as parameter. Output of the command is considered <acronym class="acronym">URI</acronym> set 
		(separated by lines).
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>command</em></span> - Command to be executed. It can
			include pseudo- variabes;
			</p></li></ul></div><p>
		WARNING: if the var you are passing out has a bash special
		character in it, the var needs to be placed inside quotes, for ex:
		exec_dset("print-contact.sh '$ct'");
		</p><p>
		This function can be used from REQUEST_ROUTE, FAILURE_ROUTE.
		</p><div class="example"><a name="id293492"></a><p class="title"><b>Example 1.4. <code class="function">exec_dset</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
exec_dset("echo TEST &gt; /tmp/test.txt");
exec_dset("echo TEST &gt; /tmp/$rU.txt");
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293510"></a>1.4.2. 
		<code class="function">exec_msg(command)</code>
		</h3></div></div></div><p>
		Executes an external command. The whole message is passed to it in 
		input, no command-line parameters are added, output of the command is 
		not processed.
		</p><p>
		See sip-server/modules/exec/etc/exec.cfg in the source tarball for 
		information on usage.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>command</em></span> - Command to be executed. It
			can include pseudo-variables.
			</p></li></ul></div><p>
		WARNING: if the var you are passing out has a bash special
		character in it, the var needs to be placed inside quotes, for ex:
		exec_msg("print-contact.sh '$ct'");
		</p><p>
		This function can be used from REQUEST_ROUTE, FAILURE_ROUTE.
		</p><div class="example"><a name="id293552"></a><p class="title"><b>Example 1.5. <code class="function">exec_msg</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
exec_msg("echo TEST &gt; /tmp/test.txt");
exec_msg("echo TEST &gt; /tmp/$rU.txt");
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293569"></a>1.4.3. 
		<code class="function">exec_avp(command [, avplist])</code>
		</h3></div></div></div><p>
		Executes an external command. Each line from output of the command
		is saved in an AVP from 'avplist'. If 'avplist' is missing, the
		AVP are named 1, 2, 3, ...
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>command</em></span> - Command to be executed. It can
			include pseudo- variabes;
			</p></li><li><p><span class="emphasis"><em>avplist</em></span> - comma separated list with AVP 
			names to store the result in;
			</p></li></ul></div><p>
		WARNING: if the var you are passing out has a bash special
		character in it, the var needs to be placed inside quotes, for ex:
		exec_avp("print-contact.sh '$ct'");
		</p><p>
			This function can be used from REQUEST_ROUTE, FAILURE_ROUTE, LOCAL_ROUTE, STARTUP_ROUTE.
		</p><div class="example"><a name="id293616"></a><p class="title"><b>Example 1.6. <code class="function">exec_avp</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
exec_avp("echo TEST");
exec_avp("echo TEST", "$avp(test)");
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293633"></a>1.4.4. 
		<code class="function">exec_getenv(environment_variable [, avp])</code>
		</h3></div></div></div><p>
		Get the value of an evironment_variable. The value is saved 
		in 'avp'. If 'avp' is missing, the AVP is named 1. If there
		is no such environment variable no value is returned.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>environment_variable</em></span> - Environent 
			variable name. It can include pseudo- variabes;
		</p></li><li><p><span class="emphasis"><em>avp</em></span> - an AVP names to store the 
			result in;
			</p></li></ul></div><p>
		WARNING: if the var you are passing out has a bash special
		character in it, the var needs to be placed inside quotes, for ex:
		exec_getenv("'$ct'");
		</p><p>
		This function can be used from REQUEST_ROUTE, FAILURE_ROUTE, LOCAL_ROUTE, STARTUP_ROUTE.
		</p><div class="example"><a name="id293681"></a><p class="title"><b>Example 1.7. <code class="function">exec_getenv</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
exec_getenv("HOSTNAME");
exec_getenv("HOSTNAME", "$avp(test)");
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293699"></a>1.5. Known Issues</h2></div></div></div><p>
		There is currently no guarantee that scripts ever return and stop 
		blocking <acronym class="acronym">SIP</acronym> server. (There is kill.c but it is not used along with 
		the current mechanisms based on popen. Besides that kill.c is ugly).
	</p></div></div></div></body></html>
