<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>mi_datagram Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284028"></a>mi_datagram Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Andreea-Ancuta</span> <span class="surname">Onofrei</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Andreea-Ancuta</span> <span class="surname">Onofrei</span></h3></div></div></div><div><p class="copyright">Copyright © 2007 Voice Sistem SRL</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 8740 $</td><td align="left">$Date: 2013-01-29 13:35:11 +0100 (Tue, 29 Jan 2013) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id280015">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id279670">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id277967">1.2. DATAGRAM command syntax</a></span></dt><dt><span class="section"><a href="#id248018">1.3. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248024">1.3.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249279">1.3.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249588">1.4. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249593">1.4.1. <code class="varname">socket_name</code> (string)</a></span></dt><dt><span class="section"><a href="#id249634">1.4.2. <code class="varname">children_count</code> (string)</a></span></dt><dt><span class="section"><a href="#id248402">1.4.3. <code class="varname">unix_socket_mode</code> (integer)</a></span></dt><dt><span class="section"><a href="#id248438">1.4.4. <code class="varname">unix_socket_group</code> (integer)
		<code class="varname">unix_socket_group</code> (string)</a></span></dt><dt><span class="section"><a href="#id293419">1.4.5. <code class="varname">unix_socket_user</code> (integer)
		<code class="varname">unix_socket_group</code> (string)</a></span></dt><dt><span class="section"><a href="#id293456">1.4.6. <code class="varname">socket_timeout</code> (integer)</a></span></dt><dt><span class="section"><a href="#id293489">1.4.7. <code class="varname">reply_indent</code> (string)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293528">1.5. Exported Functions</a></span></dt><dt><span class="section"><a href="#id293537">1.6. Example</a></span></dt></dl></dd><dt><span class="chapter"><a href="#id294034">2. Frequently Asked Questions</a></span></dt></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249613">Set <code class="varname">socket_name</code> parameter</a></dt><dt>1.2. <a href="#id248385">Set <code class="varname">children_count</code> parameter</a></dt><dt>1.3. <a href="#id248421">Set <code class="varname">unix_socket_mode</code> parameter</a></dt><dt>1.4. <a href="#id293402">Set <code class="varname">unix_socket_group</code> parameter</a></dt><dt>1.5. <a href="#id293439">Set <code class="varname">unix_socket_user</code> parameter</a></dt><dt>1.6. <a href="#id293473">Set <code class="varname">socket_timeout</code> parameter</a></dt><dt>1.7. <a href="#id293511">Set <code class="varname">reply_indent</code> parameter</a></dt><dt>1.8. <a href="#id293550">DATAGRAM request</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id280015"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id279670"></a>1.1. Overview</h2></div></div></div><p>
		This is a module which provides a UNIX/UDP SOCKET transport layer 
		implementation for the Management Interface. 
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id277967"></a>1.2. DATAGRAM command syntax</h2></div></div></div><p>
		The external commands issued via DATAGRAM interface must follow the
		following syntax:
		</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>
			request = first_line (argument '\n')*
			</em></span></p></li><li><p><span class="emphasis"><em>
			first_line = ':'command_name':''\n'
			</em></span></p></li><li><p><span class="emphasis"><em>
			argument = (arg_name '::' (arg_value)? ) | (arg_value)
			</em></span></p></li><li><p><span class="emphasis"><em>
			arg_name = not-quoted_string
			</em></span></p></li><li><p><span class="emphasis"><em>
			arg_value = not-quoted_string | '"' string '"'
			</em></span></p></li><li><p><span class="emphasis"><em>
			not-quoted_string = string - {',",\n,\r}
			</em></span></p></li></ul></div><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248018"></a>1.3. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248024"></a>1.3.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>No dependencies on other OpenSIPS modules</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249279"></a>1.3.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before 
		running OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>none</em></span>
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249588"></a>1.4. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249593"></a>1.4.1. <code class="varname">socket_name</code> (string)</h3></div></div></div><p>
		The name of a UNIX SOCKET or an IP address. 
		The UNIX datagram or UDP socket will be created using this parameter 
		in order to read the external commands.
		Both IPv4 and IPv6 are supported. 
		</p><p>
		<span class="emphasis"><em>
			Default value is NONE.
		</em></span>
		</p><div class="example"><a name="id249613"></a><p class="title"><b>Example 1.1. Set <code class="varname">socket_name</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mi_datagram", "socket_name", "/tmp/opensips.sock")
...
modparam("mi_datagram", "socket_name", "udp:192.168.2.133:8080")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249634"></a>1.4.2. <code class="varname">children_count</code> (string)</h3></div></div></div><p>
		The number of child processes to be created. Each child process
		will be a datagram server.
		</p><p>
		<span class="emphasis"><em>
			Default value is 1.
		</em></span>
		</p><div class="example"><a name="id248385"></a><p class="title"><b>Example 1.2. Set <code class="varname">children_count</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mi_datagram", "children_count", 3)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248402"></a>1.4.3. <code class="varname">unix_socket_mode</code> (integer)</h3></div></div></div><p>
		Permission to be used for creating the listening UNIX datagram socket. 
		Not necessary for a UDP socket.
		It follows the UNIX conventions.
		</p><p>
		<span class="emphasis"><em>
			Default value is 0660 (rw-rw----).
		</em></span>
		</p><div class="example"><a name="id248421"></a><p class="title"><b>Example 1.3. Set <code class="varname">unix_socket_mode</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mi_datagram", "unix_socket_mode", 0600)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248438"></a>1.4.4. <code class="varname">unix_socket_group</code> (integer)
		<code class="varname">unix_socket_group</code> (string)</h3></div></div></div><p>
		Group to be used for creating the listening UNIX socket.
		</p><p>
		<span class="emphasis"><em>
			Default value is the inherited one.
		</em></span>
		</p><div class="example"><a name="id293402"></a><p class="title"><b>Example 1.4. Set <code class="varname">unix_socket_group</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mi_datagram", "unix_socket_group", 0)
modparam("mi_datagram", "unix_socket_group", "root")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293419"></a>1.4.5. <code class="varname">unix_socket_user</code> (integer)
		<code class="varname">unix_socket_group</code> (string)</h3></div></div></div><p>
		User to be used for creating the listening UNIX socket.
		</p><p>
		<span class="emphasis"><em>
			Default value is the inherited one.
		</em></span>
		</p><div class="example"><a name="id293439"></a><p class="title"><b>Example 1.5. Set <code class="varname">unix_socket_user</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mi_datagram", "unix_socket_user", 0)
modparam("mi_datagram", "unix_socket_user", "root")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293456"></a>1.4.6. <code class="varname">socket_timeout</code> (integer)</h3></div></div></div><p>
		The reply will expire after trying to sent it for socket_timeout 
		miliseconds. 
		</p><p>
		<span class="emphasis"><em>
			Default value is 2000.
		</em></span>
		</p><div class="example"><a name="id293473"></a><p class="title"><b>Example 1.6. Set <code class="varname">socket_timeout</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mi_datagram", "socket_timeout", 2000)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293489"></a>1.4.7. <code class="varname">reply_indent</code> (string)</h3></div></div></div><p>
		Strings to be used for line indentation. As the MI data structure 
		is tree oriendeted, the depth level will printed as indentation.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">"\t" (TAB)</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id293511"></a><p class="title"><b>Example 1.7. Set <code class="varname">reply_indent</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mi_datagram", "reply_indent", "    ")
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293528"></a>1.5. Exported Functions</h2></div></div></div><p>
		No function exported to be used from configuration file.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293537"></a>1.6. Example</h2></div></div></div><p>
		This is an example showing the DATAGRAM format for the 
		&#8220;<span class="quote">get_statistics dialog: tm:</span>&#8221; MI commad:
		response.
		</p><div class="example"><a name="id293550"></a><p class="title"><b>Example 1.8. DATAGRAM request</b></p><div class="example-contents"><pre class="programlisting">

:get_statistics:\n
dialog:\n
tm:\n

</pre></div></div><br class="example-break"></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id294034"></a>Chapter 2. Frequently Asked Questions</h2></div></div></div><div class="qandaset"><table border="0" summary="Q and A Set"><col align="left" width="1%"><tbody><tr class="question"><td align="left" valign="top"><a name="id294038"></a><a name="id293721"></a><p><b>2.1.</b></p></td><td align="left" valign="top"><p>Both UNIX and UDP type of socket can be created 
			simultaneusly?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			This version supports only one kind of socket at a time.
			If there are more than one value set for socket_name the last one
			will take effect.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id294046"></a><a name="id294048"></a><p><b>2.2.</b></p></td><td align="left" valign="top"><p>Is there a limit in the datagram request's size?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			The maximum length of a datagram request or reply is 65457 bytes.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id294063"></a><a name="id294065"></a><p><b>2.3.</b></p></td><td align="left" valign="top"><p>Where can I find more about OpenSIPS?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			Take a look at <a class="ulink" href="http://www.opensips.org/" target="_top">http://www.opensips.org/</a>.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id294091"></a><a name="id294093"></a><p><b>2.4.</b></p></td><td align="left" valign="top"><p>Where can I post a question about this module?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			First at all check if your question was already answered on one of
			our mailing lists: 
		</p><div class="itemizedlist"><ul type="disc"><li><p>User Mailing List - <a class="ulink" href="http://lists.opensips.org/cgi-bin/mailman/listinfo/users" target="_top">http://lists.opensips.org/cgi-bin/mailman/listinfo/users</a></p></li><li><p>Developer Mailing List - <a class="ulink" href="http://lists.opensips.org/cgi-bin/mailman/listinfo/devel" target="_top">http://lists.opensips.org/cgi-bin/mailman/listinfo/devel</a></p></li></ul></div><p>
			E-mails regarding any stable OpenSIPS release should be sent to 
			<code class="email">&lt;<a class="email" href="mailto:users@lists.opensips.org">users@lists.opensips.org</a>&gt;</code> and e-mails regarding development versions
			should be sent to <code class="email">&lt;<a class="email" href="mailto:devel@lists.opensips.org">devel@lists.opensips.org</a>&gt;</code>.
		</p><p>
			If you want to keep the mail private, send it to 
			<code class="email">&lt;<a class="email" href="mailto:users@lists.opensips.org">users@lists.opensips.org</a>&gt;</code>.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id294149"></a><a name="id294151"></a><p><b>2.5.</b></p></td><td align="left" valign="top"><p>How can I report a bug?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			Please follow the guidelines provided at:
			<a class="ulink" href="https://github.com/OpenSIPS/opensips/issues" target="_top">https://github.com/OpenSIPS/opensips/issues</a>.
		</p></td></tr></tbody></table></div></div></div></body></html>
