<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>SMS Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id249239"></a><acronym class="acronym">SMS</acronym> Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Bogdan-Andrei</span> <span class="surname">Iancu</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Bogdan-Andrei</span> <span class="surname">Iancu</span></h3></div></div></div><div><p class="copyright">Copyright © 2003 FhG FOKUS</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 8740 $</td><td align="left">$Date: 2013-01-29 13:35:11 +0100 (Tue, 29 Jan 2013) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id274050">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id273228">1.1. Overview</a></span></dt><dd><dl><dt><span class="section"><a href="#id284058">1.1.1. Hardware Requirements</a></span></dt><dt><span class="section"><a href="#id284084">1.1.2. Numbering Plan</a></span></dt><dt><span class="section"><a href="#id249564">1.1.3. Address Mapping</a></span></dt></dl></dd><dt><span class="section"><a href="#id248869">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248875">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248898">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id293410">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id293415">1.3.1. <code class="varname">modems</code> (string)</a></span></dt><dt><span class="section"><a href="#id293554">1.3.2. <code class="varname">networks</code> (string)</a></span></dt><dt><span class="section"><a href="#id293634">1.3.3. <code class="varname">links</code> (string)</a></span></dt><dt><span class="section"><a href="#id293692">1.3.4. <code class="varname">default_net</code> (string)</a></span></dt><dt><span class="section"><a href="#id293829">1.3.5. <code class="varname">max_sms_parts</code> (integer)</a></span></dt><dt><span class="section"><a href="#id293876">1.3.6. <code class="varname">domain</code> (string)</a></span></dt><dt><span class="section"><a href="#id293912">1.3.7. <code class="varname">use_contact</code> (integer)</a></span></dt><dt><span class="section"><a href="#id293955">1.3.8. <code class="varname">sms_report_type</code> (integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#sec-exported-functions">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id294143">1.4.1. 
		<code class="function">sms_send_msg_to_net(network_name)</code>
		</a></span></dt><dt><span class="section"><a href="#id294204">1.4.2. 
		<code class="function">sms_send_msg()</code>
		</a></span></dt></dl></dd></dl></dd><dt><span class="chapter"><a href="#id295160">2. Developer Guide</a></span></dt></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id293537">Set <code class="varname">modems</code> parameter</a></dt><dt>1.2. <a href="#id293618">Set <code class="varname">networks</code> parameter</a></dt><dt>1.3. <a href="#id293661">Set <code class="varname">links</code> parameter</a></dt><dt>1.4. <a href="#id293813">Set <code class="varname">default_net</code> parameter</a></dt><dt>1.5. <a href="#id293860">Set <code class="varname">max_sms_parts</code> parameter</a></dt><dt>1.6. <a href="#id293896">Set <code class="varname">domain_str</code> parameter</a></dt><dt>1.7. <a href="#id293939">Set <code class="varname">use_contact</code> parameter</a></dt><dt>1.8. <a href="#id294016">Set <code class="varname">sms_report_type</code> parameter</a></dt><dt>1.9. <a href="#id294184"><code class="function">sms_send_msg_to_net</code> usage</a></dt><dt>1.10. <a href="#id294221"><code class="function">sms_send_msg</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id274050"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id273228"></a>1.1. Overview</h2></div></div></div><p>
		This module provides a way of communication between <acronym class="acronym">SIP</acronym> network 
		(via <acronym class="acronym">SIP</acronym> MESSAGE) and <acronym class="acronym">GSM</acronym> networks 
		(via ShortMessageService). Communication is possible from
		<acronym class="acronym">SIP</acronym> to <acronym class="acronym">SMS</acronym> and vice versa. The module provides 
		facilities like <acronym class="acronym">SMS</acronym> confirmation--the gateway can 
		confirm to the <acronym class="acronym">SIP</acronym> user if his message really reached its 
		destination as a <acronym class="acronym">SMS</acronym>--or multi-part
		messages--if a <acronym class="acronym">SIP</acronym> messages is too long it will be split and sent 
		as multiple
		<acronym class="acronym">SMS</acronym>.
	</p><p>
		Errors occurred because of an invalid number or a too long message or 
		because of an internal modem malfunction are reported back to the 
		<acronym class="acronym">SIP</acronym> user via a <acronym class="acronym">SIP</acronym> message containing explanations regarding the 
		error.
	</p><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id284058"></a>1.1.1. Hardware Requirements</h3></div></div></div><p>
		The <acronym class="acronym">SMS</acronym> module needs a <acronym class="acronym">GSM</acronym> modem 
		to be able to send/receive the <acronym class="acronym">SMS</acronym> messages. 
		Usually, this kind of modems are externals, linked to the machine via 
		serial cable. The modem can be a dedicated one (as the ones provided 
		by FALCOM) or can be a <acronym class="acronym">GSM</acronym> telephone that
		has an internal modem (as the latest mobile phones from NOKIA and 
		ERICSSON).
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id284084"></a>1.1.2. Numbering Plan</h3></div></div></div><p>
		The gateway accepts and advertises phone numbers in international 
		format, more specific like: +(international code)(area code)(number). 
		Ex: Germany, D1 = +49 170 5678181 Romania, Connex = +40 722 123456. 
		A number in this format is expected to be placed as username into 
		<acronym class="acronym">RURI</acronym> or in the To header. If <acronym class="acronym">RURI</acronym> 
		misses the username, the To header will be consider. Also,
		the gateway will advertise in this format the username in Contact
		headers (in <acronym class="acronym">SIP</acronym> replies and requests) and in From headers 
		(in <acronym class="acronym">SIP</acronym> requests).
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249564"></a>1.1.3. Address Mapping</h3></div></div></div><p>
		To identify the destination number of the <acronym class="acronym">SMS</acronym>, the 
		gateway expects to have a mobile number in username of the <acronym class="acronym">SIP</acronym> 
		destination address (for example sip:+401704678811@sidomain.net). For 
		the reverse direction, because the gateway has only one 
		<acronym class="acronym">GSM</acronym> number, the destination <acronym class="acronym">SIP</acronym> address has to be
		encapsulated into the <acronym class="acronym">SMS</acronym> body. The gateway expects 
		to find a <acronym class="acronym">SIP</acronym> address at the beginning of the <acronym class="acronym">SMS</acronym> 
		body in &#8220;<span class="quote">sip:user.host</span>&#8221; format. Everything before the 
		<acronym class="acronym">SIP</acronym> address will be discarded, the useful text begins exactly after 
		the address (for example 
		SMS=&#8220;<span class="quote">For sip:user@host hello world!!</span>&#8221; -&gt; SIP=
		&#8220;<span class="quote">hello world</span>&#8221;) In order to facilitate replying, the 
		gateway sends all the <acronym class="acronym">SMS</acronym> messages with a header 
		containing the source <acronym class="acronym">SIP</acronym> address in the following format: 
		&#8220;<span class="quote">From sip:user@host (if you reply DONOT remove 
		it)&lt;new_line&gt;</span>&#8221;. When an <acronym class="acronym">SMS</acronym>-reply is 
		received having this header (all of it or truncated at the end), the 
		header will be left out (it will not be in the <acronym class="acronym">SIP</acronym> message).
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248869"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248875"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>tm - Transaction Manager</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248898"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293410"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293415"></a>1.3.1. <code class="varname">modems</code> (string)</h3></div></div></div><p>
		Define and configure one or more <acronym class="acronym">GSM</acronym> modems.
		</p><pre class="programlisting">
modems_value	 = modem_definition *( ";" modem_definition )
modem_definition = modem_name "[" list_of_params "]"
list_of_params   = modem_param *( ";" modem_param )
modem_param	  = name "=" value
</pre><p>
		The following parameters can be used:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
			d=device (mandatory) - Device associated with modem 
			(/dev/ttyS0, /dev/modem, etc.).
			</p></li><li><p>
			p=pin (optional) - <acronym class="acronym">SIM</acronym> <acronym class="acronym">PIN</acronym> - 
			default is NULL.
			</p></li><li><p>
			m=mode (optional) - Modem working mode
			(&#8220;<span class="quote">ASCII</span>&#8221;,&#8220;<span class="quote">OLD</span>&#8221;,&#8220;<span class="quote">DIGICOM</span>&#8221;,
			&#8220;<span class="quote">NEW</span>&#8221;). Default value is &#8220;<span class="quote">NEW</span>&#8221;.
			</p></li><li><p>
			c=SMS_Center (optional) - <acronym class="acronym">SMS</acronym> center number for 
			that modem. Default is the <acronym class="acronym">SMS</acronym> center set on the
			<acronym class="acronym">SIM</acronym> card.
			</p></li><li><p>
			b=baudrate (optional) - Default is 19600.
			</p></li><li><p>
			r=retry (optional) - How many times to try to re-send a
			<acronym class="acronym">SMS</acronym> that reported error. Default is twice.
			</p></li><li><p>
			l=looping (optional) - Time for modem to wait before performing a 
			new check for incomimg/outgoing <acronym class="acronym">SMS</acronym>/SIP_MSG.
			Default is 20.
			</p></li></ul></div><p>
		<span class="emphasis"><em>
			No default value, the parameter is mandatory.
		</em></span>
		</p><div class="example"><a name="id293537"></a><p class="title"><b>Example 1.1. Set <code class="varname">modems</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("sms", "modems", "Nokia [d=/dev/ttyS1;b=9600;m=new;l=30] ")
modparam("sms", "modems", "Nokia[d=/dev/ttyS1];Siemens[d=/dev/ttyS2]")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293554"></a>1.3.2. <code class="varname">networks</code> (string)</h3></div></div></div><p>
		Define and configure used <acronym class="acronym">GSM</acronym> networks.
		</p><pre class="programlisting">
networks_value = net_definition *( ";" net_definition )
net_definition = net_name "[" list_of_params "]"
list_of_params = set_param *( ";" set_param )
set_param	  = name "=" value
</pre><p>
		The following parameters can be used:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
			m=msx_sms_per_call (optional) - Maximum number of 
			<acronym class="acronym">SMS</acronym> send / received from that net in one modem 
			loop. Default is 10. This parameter was introduced to avoid 
			starvation.
			</p><p>
			Example of the starvation--a modem can send 
			<acronym class="acronym">SMS</acronym> for more than 1 networks. If you have a 
			huge number of <acronym class="acronym">SMS</acronym> for the first network and 
			the number of incoming <acronym class="acronym">SIP</acronym> messages is equal to the sent
			<acronym class="acronym">SMS</acronym> per same unit of time, the modem will 
			never get to send <acronym class="acronym">SMS</acronym> for the next networks.
			</p></li></ul></div><p>
		<span class="emphasis"><em>
			No default value, the parameter is mandatory.
		</em></span>
		</p><div class="example"><a name="id293618"></a><p class="title"><b>Example 1.2. Set <code class="varname">networks</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("sms", "networks", "D1 [m=10] ;d2[ m=20]")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293634"></a>1.3.3. <code class="varname">links</code> (string)</h3></div></div></div><p>
		Define from which network each modem should send <acronym class="acronym">SMS</acronym>.
		</p><pre class="programlisting">
links_value = modem_assoc *( ";" modem_assoc )
modem_assoc = modem_name "[" list_of_networks "]"
list_of_networks = network *( ";" network )
</pre><p>
		<span class="emphasis"><em>
			No default value, the parameter is mandatory.
		</em></span>
		</p><div class="example"><a name="id293661"></a><p class="title"><b>Example 1.3. Set <code class="varname">links</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("sms", "links", "NOKIA[D1;d2]")
...
</pre></div></div><br class="example-break"><p>
		The modem NOKIA will send <acronym class="acronym">SMS</acronym> from D1 and D2 net 
		(in this order !). if in a net queue are more then max_sms_per_call 
		<acronym class="acronym">SMS</acronym> the modem will <span class="emphasis"><em>not sleep</em></span> 
		before starting the next loop ! Shortly, if messages are waiting to
		be sent, the modem will not go in sleep.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293692"></a>1.3.4. <code class="varname">default_net</code> (string)</h3></div></div></div><p>
		The default network to use. If no one specified, the first defined
		network is used. This parameter is useful only if the 
		&#8220;<span class="quote">sms_send_msg</span>&#8221; exported function is used 
		(see <a class="xref" href="#sec-exported-functions" title="1.4. Exported Functions">Section 1.4, &#8220;Exported Functions&#8221;</a>).
		</p><div class="example"><a name="id293813"></a><p class="title"><b>Example 1.4. Set <code class="varname">default_net</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("sms", "default_net", "D1")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293829"></a>1.3.5. <code class="varname">max_sms_parts</code> (integer)</h3></div></div></div><p>
		Shows in how many parts (<acronym class="acronym">SMS</acronym> messages) a <acronym class="acronym">SIP</acronym> 
		message can be split. If exceeded, the <acronym class="acronym">SIP</acronym> message will be sent 
		truncated and the <acronym class="acronym">SIP</acronym> user will get back another message containing 
		the unsent part.
		</p><p>
		<span class="emphasis"><em>
			Default value is 4.
		</em></span>
		</p><div class="example"><a name="id293860"></a><p class="title"><b>Example 1.5. Set <code class="varname">max_sms_parts</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("sms", "max_sms_parts", 10)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293876"></a>1.3.6. <code class="varname">domain</code> (string)</h3></div></div></div><p>
		Specify a fake domain name to be used by the gateway. The Contact 
		headers and the From header from request will be construct based on 
		this fake domain name. It's useful when the gateway is transparently 
		hidden behind a proxy/register (located on different machines).
		</p><p>
		<span class="emphasis"><em>
			Default is the name of the machine the gateway is running on.
		</em></span>
		</p><div class="example"><a name="id293896"></a><p class="title"><b>Example 1.6. Set <code class="varname">domain_str</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("sms", "domain_str", "foo.bar")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293912"></a>1.3.7. <code class="varname">use_contact</code> (integer)</h3></div></div></div><p>
		If a contact header should be added to the outgoing <acronym class="acronym">SIP</acronym> messages. 
		Even if the <acronym class="acronym">SIP</acronym> draft forbids this, some <acronym class="acronym">UAS</acronym> require it. 
		</p><p>
		<span class="emphasis"><em>
			Default is 0 (no).
		</em></span>
		</p><div class="example"><a name="id293939"></a><p class="title"><b>Example 1.7. Set <code class="varname">use_contact</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("sms", "use_contact", 1)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293955"></a>1.3.8. <code class="varname">sms_report_type</code> (integer)</h3></div></div></div><p>
		If the modem should ask for <acronym class="acronym">SMS</acronym> confirmation from the
		<acronym class="acronym">SMS</acronym> Center. If the <acronym class="acronym">SMSC</acronym> reply 
		with an error code, the gateway will send back to <acronym class="acronym">SIP</acronym> user a <acronym class="acronym">SIP</acronym> 
		message containing the text (or part of it) that couldn't be send. Two 
		report mechanisms are implemented:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
			1 - the reports are delivered by the <acronym class="acronym">GSM</acronym> device 
			as <acronym class="acronym">SMS</acronym> reports (so far supported only by Nokia 
			modems);
			</p></li><li><p>
			2 - the reports are delivered as async. <acronym class="acronym">CDS</acronym> 
			responses (supported by almost all modems, except Ericsson).
			</p></li></ul></div><p>
		<span class="emphasis"><em>
			Default is 0 (no report).
		</em></span>
		</p><div class="example"><a name="id294016"></a><p class="title"><b>Example 1.8. Set <code class="varname">sms_report_type</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("sms", "sms_report_type", 1)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="sec-exported-functions"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id294143"></a>1.4.1. 
		<code class="function">sms_send_msg_to_net(network_name)</code>
		</h3></div></div></div><p>
		Put the <acronym class="acronym">SIP</acronym> msg in the specified network queue. The function return 
		error if the number encapsulated into <acronym class="acronym">SIP</acronym> message is malformed, if 
		the content_type is incorrect or because of some internal failures.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p>
			<span class="emphasis"><em>network_name</em></span> - Name of network.
			</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id294184"></a><p class="title"><b>Example 1.9. <code class="function">sms_send_msg_to_net</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (sms_send_msg_to_net("D1"))
{
	if (!t_reply("202", "yes sir, SMS sent over"))
	{
		# if replying failed, retry statelessly
		sl_reply_error();
	};
} else {
	if (!t_reply("502", "Bad gateway - SMS error"))
	{
		# if replying failed, retry statelessly
		sl_reply_error();
	};
	exit;
};
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id294204"></a>1.4.2. 
		<code class="function">sms_send_msg()</code>
		</h3></div></div></div><p>
		The same as the previous one, but use the default network queue.
		</p><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id294221"></a><p class="title"><b>Example 1.10. <code class="function">sms_send_msg</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (sms_send_msg_to_net())
{
	if (!t_reply("202", "yes sir, SMS sent over"))
	{
		# if replying failed, retry statelessly
		sl_reply_error();
	};
} else {
	if (!t_reply("502", "Bad gateway - SMS error"))
	{
		# if replying failed, retry statelessly
		sl_reply_error();
	};
	exit;
};
...
</pre></div></div><br class="example-break"></div></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id295160"></a>Chapter 2. Developer Guide</h2></div></div></div><p>
	Each modem forks its own process for sending /fetching <acronym class="acronym">SMS</acronym>. Communication
	and queuing between OpenSIPS working processes and modem processes is done with pipes.
    </p></div></div></body></html>
