<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>SNMPStats Module (Simple Network Management Protocal Statistic Module)</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284028"></a>SNMPStats Module (Simple Network Management Protocal Statistic Module)</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Jeffrey</span> <span class="surname">Magder</span></h3><div class="affiliation"><span class="orgname">SOMA Networks, Inc.<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Jeffrey</span> <span class="surname">Magder</span></h3></div></div></div><div><p class="copyright">Copyright © 2006 SOMA Networks, Inc.</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date: 2013-01-29 13:35:11 +0100 (Tue, 29 Jan 2013) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id277967">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id284066">1.1. Overview</a></span></dt><dd><dl><dt><span class="section"><a href="#id284079">1.1.1. General Scalar Statistics</a></span></dt><dt><span class="section"><a href="#id248026">1.1.2. SNMP Tables</a></span></dt><dt><span class="section"><a href="#id249278">1.1.3. Alarm Monitoring</a></span></dt></dl></dd><dt><span class="section"><a href="#id249613">1.2. How it works</a></span></dt><dd><dl><dt><span class="section"><a href="#id249618">1.2.1. How the SNMPStats module gets its data</a></span></dt><dt><span class="section"><a href="#id248389">1.2.2. How data is moved from the SNMPStats module to a NOC</a></span></dt></dl></dd><dt><span class="section"><a href="#id248423">1.3. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248428">1.3.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id293421">1.3.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id293448">1.4. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id293454">1.4.1. <code class="varname">sipEntityType</code> (String) </a></span></dt><dt><span class="section"><a href="#id293494">1.4.2. <code class="varname">MsgQueueMinorThreshold</code> (Integer)</a></span></dt><dt><span class="section"><a href="#id293526">1.4.3. <code class="varname">MsgQueueMajorThreshold</code> (Integer)</a></span></dt><dt><span class="section"><a href="#id293559">1.4.4. <code class="varname">dlg_minor_threshold</code> (Integer)</a></span></dt><dt><span class="section"><a href="#id293593">1.4.5. <code class="varname">dlg_major_threshold</code> (Integer)</a></span></dt><dt><span class="section"><a href="#id293627">1.4.6. <code class="varname">snmpgetPath</code> (String)</a></span></dt><dt><span class="section"><a href="#id293666">1.4.7. <code class="varname">snmpCommunity</code> (String)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293707">1.5. Exported Functions</a></span></dt><dt><span class="section"><a href="#id293716">1.6. Installation and Running</a></span></dt><dd><dl><dt><span class="section"><a href="#id293726">1.6.1. 
	Compiling the SNMPStats Module
	</a></span></dt><dt><span class="section"><a href="#id293758">1.6.2. 
	Configuring NetSNMP to allow connections from the SNMPStats module.
	</a></span></dt><dt><span class="section"><a href="#id293806">1.6.3. 
	Configuring the SNMPStats module for communication with a Master Agent
	</a></span></dt><dt><span class="section"><a href="#id293834">1.6.4. 
	Testing for a proper Configuration
	</a></span></dt></dl></dd></dl></dd><dt><span class="chapter"><a href="#id294628">2. Frequently Asked Questions</a></span></dt></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id293473">Setting the <code class="varname">sipEntityType</code> parameter</a></dt><dt>1.2. <a href="#id293507">Setting the <code class="varname">MsgQueueMinorThreshold</code> parameter</a></dt><dt>1.3. <a href="#id293540">Setting the <code class="varname">MsgQueueMajorThreshold</code> parameter</a></dt><dt>1.4. <a href="#id293573">Setting the <code class="varname">dlg_minor_threshold</code> parameter</a></dt><dt>1.5. <a href="#id293606">Setting the <code class="varname">dlg_major_threshold</code> parameter</a></dt><dt>1.6. <a href="#id293649">Setting the <code class="varname">snmpgetPath</code> parameter</a></dt><dt>1.7. <a href="#id293689">Setting the <code class="varname">snmpCommunity</code> parameter</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id277967"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284066"></a>1.1. Overview</h2></div></div></div><p>The SNMPStats module provides an SNMP management interface
		to OpenSIPS.  Specifically, it provides general SNMP queryable 
		scalar statistics, table representations of more complicated data such as 
		user and contact information, and alarm monitoring capabilities.
		</p><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id284079"></a>1.1.1. General Scalar Statistics</h3></div></div></div><p>
			The SNMPStats module provides a number of general scalar statistics.  
			Details are available in OPENSER-MIB, OPENSER-REG-MIB, 
			OPENSER-SIP-COMMON-MIB, and OPENSER-SIP-SERVER-MIB.  But briefly, 
			these scalars are:
			</p><p>
			openserSIPProtocolVersion, openserSIPServiceStartTime, openserSIPEntityType,
			openserSIPSummaryInRequests, openserSIPSummaryOutRequest, 
			openserSIPSummaryInResponses, openserSIPSummaryOutResponses,
			openserSIPSummaryTotalTransactions, openserSIPCurrentTransactions, 
			openserSIPNumUnsupportedUris, openserSIPNumUnsupportedMethods, 
			openserSIPOtherwiseDiscardedMsgs, openserSIPProxyStatefulness
			openserSIPProxyRecordRoute, openserSIPProxyAuthMethod, 
			openserSIPNumProxyRequireFailures, openserSIPRegMaxContactExpiryDuration,
			openserSIPRegMaxUsers, openserSIPRegCurrentUsers, 
			openserSIPRegDfltRegActiveInterval, openserSIPRegAcceptedRegistrations,
			openserSIPRegRejectedRegistrations, openserMsgQueueDepth.
			openserCurNumDialogs, openserCurNumDialogsInProgress, 
			openserCurNumDialogsInSetup, openserTotalNumFailedDialogSetups
			</p><p>
			There are also scalars associated with alarms.  They are as follows:
			</p><p>
			openserMsgQueueMinorThreshold, openserMsgQueueMajorThreshold,
			openserMsgQueueDepthAlarmStatus, openserMsgQueueDepthMinorAlarm,
			openserMsgQueueDepthMajorAlarm, openserDialogLimitMinorThreshold,
			openserDialogLimitMajorThreshold, openserDialogUsageState,
			openserDialogLimitAlarmStatus, openserDialogLimitMinorAlarm,
			openserDialogLimitMajorAlarm
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248026"></a>1.1.2. SNMP Tables</h3></div></div></div><p>
			The SNMPStats module provides several tables, containing more complicated
			data.  The current available tables are:
			</p><p>
			openserSIPPortTable, openserSIPMethodSupportedTable, 
			openserSIPStatusCodesTable, openserSIPRegUserTable, openserSIPContactTable,
			openserSIPRegUserLookupTable
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249278"></a>1.1.3. Alarm Monitoring</h3></div></div></div><p>
			If enabled, the SNMPStats module will monitor for alarm conditions. 
			Currently, there are two alarm types defined.  
			</p><div class="orderedlist"><ol type="1"><li><p>
				The number of active dialogs has passed a minor or major threshold.
				The idea is that a network operation centre can be made aware that 
				their SIP servers may be overloaded, without having to explicitly
				check for this condition.
				</p><p>
				If a minor or major condition has occured, then a 
				openserDialogLimitMinorEvent trap or a 
				openserDialogLimitMajorEvent trap will be generated, 
				respectively. The minor and major thresholds are
				described in the parameters section below.
				</p></li><li><p>
				The number of bytes waiting to be consumed across all of OpenSIPSs
				listening ports has passed a minor or major threshold.  The idea is
				that a network operation centre can be made aware that a machine 
				hosting a SIP server may be entering a degraded state, and to 
				investigate why this is so. 
				</p><p>
				If the number of bytes to be consumed passes a minor or major 
				threshold, then a openserMsgQueueDepthMinorEvent or 
				openserMsgQueueDepthMajorEvent trap will be sent out, respectively.
				</p></li></ol></div><p>
			Full details of these traps can be found in the distributions OPENSER-MIB
			file.  
			</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249613"></a>1.2. How it works</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249618"></a>1.2.1. How the SNMPStats module gets its data</h3></div></div></div><p>
	The SNMPStats module uses OpenSIPSs internal statistic framework to collect most of its
	data. However, there are two exceptions.  
	</p><div class="orderedlist"><ol type="1"><li><p>
			The openserSIPRegUserTable and openserSIPContactTable rely on the usrloc 
			modules	callback system.  Specifically, the SNMPStats module will receive 
			callbacks whenever a user/contact is added to the system.
			</p></li><li><p>
			The SNMPStats modules openserSIPMsgQueueDepthMinorEvent and 
			openserSIPMsgQueueDepthMajorEvent alarms rely on the OpenSIPS core to find out
			what interfaces, ports, and transports OpenSIPS is listening on.  However,
			the module will actually query the proc file system to find out the number
			of bytes waiting to be consumed.  (Currently, this will only work on systems
			providing the proc file system).
			</p></li></ol></div><p> 
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248389"></a>1.2.2. How data is moved from the SNMPStats module to a NOC</h3></div></div></div><p>
	We have now explained how the SNMPStats module gathers its data. We still have not
	explained how it exports this data to a NOC (Network Operations Centre), or
	administrator.
	</p><p>
	The SNMPStats module expects to connect to a <span class="emphasis"><em>Master Agent</em></span>.  This
	would be a NetSNMP daemon running either on the same system as the OpenSIPS instance, or 
	on another system.  (Communication can take place over TCP, so there is no restriction
	that this daemon need be on the same system as OpenSIPS).
	</p><p>
	If the master agent is unavailable when OpenSIPS first starts up, the SNMPStats module will
	continue to run.  However, you will not be able to query it.  Thankfully, the SNMPStats
	module continually looks for its master agent.  So even if the master agent is started late, 
	or if the link to the SNMPStats module is severed due to a temporary hardware failure
	or crashed and restarted master agent, the link will eventually be re-established.  No
	data should be lost, and querying can begin again. 
	</p><p>
	To request for this data, you will need to query the master agent.  The master agent will
	then redirect the request to the SNMPStats module, which will respond to the master agent, 
	which will in turn respond to your request.  
	</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248423"></a>1.3. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248428"></a>1.3.1. OpenSIPS Modules</h3></div></div></div><p>
		The SNMPStats module provides a plethora of statistics, some of which are collected
		by other modules.  If the dependent modules are not loaded then those specific 
		statistics will still be returned, but with zeroed values.  All other statistics will
		continue to function normally.  This means that the SNMPStats module has no  
		<span class="emphasis"><em>hard/mandatory</em></span> dependencies on other modules.  There are however,
		<span class="emphasis"><em>soft</em></span> dependencies, as follows:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
		<span class="emphasis"><em>usrloc</em></span> - all scalars and tables relating to users and contacts are
		dependent on the usrloc module.  If the module is not loaded, the respective tables
		will be empty. 
		</p></li><li><p>
		<span class="emphasis"><em>dialog</em></span> - all scalars relating to the number of dialogs are 
		dependent on the presence of the dialog module.  Furthermore, if the module is 
		not loaded, then the openserDialogLimitMinorEvent, and openserDialogLimitMajorEvent
		alarm will be disabled. 
		</p></li></ul></div><p>
		The contents of the openserSIPMethodSupportedTable change depending on which modules
		are loaded.  
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293421"></a>1.3.2. External Libraries or Applications</h3></div></div></div><p>
	The following libraries or applications must be installed before running
	OpenSIPS with this module loaded:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
			<span class="emphasis"><em>NetSNMP v5.3 or greater</em></span> - NetSNMP must be around 
			at the time of compilation.  Furthermore, there are several shared objects
			that must be loadable at the time SNMPStats is loaded.  This means that
			NetSNMP must be installed (but not necessarily running) on the system that
			has loaded the SNMPStats module.  (Details can be found in the compilation 
			section	below).
		</p></li></ul></div><p>
	</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293448"></a>1.4. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293454"></a>1.4.1. <code class="varname">sipEntityType</code> (String) </h3></div></div></div><p>
		This parameter describes the entity type for this OpenSIPS instance,
		and will be used in determining what is returned for the
		openserSIPEntityType scalar. Valid parameters are:
		</p><p>
		<span class="emphasis"><em>
		registrarServer, redirectServer, proxyServer, userAgent, other
		</em></span>
		</p><div class="example"><a name="id293473"></a><p class="title"><b>Example 1.1. Setting the <code class="varname">sipEntityType</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("snmpstats", "sipEntityType", "registrarServer")
modparam("snmpstats", "sipEntityType", "proxyServer")
...
		</pre></div></div><br class="example-break"><p>
		Note that as the above example shows, you can define this parameter more
		than once.  This is of course because a given OpenSIPS instance can take on
		more than one role.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293494"></a>1.4.2. <code class="varname">MsgQueueMinorThreshold</code> (Integer)</h3></div></div></div><p>
		The SNMPStats module monitors the number of bytes waiting to be consumed by 
		OpenSIPS.  If the number of bytes waiting to be consumed exceeds a minor
		threshold, the SNMPStats module will send out an openserMsgQueueDepthMinorEvent
		trap to signal that an alarm condition has occured.  The minor threshold is set
		with the MsgQueueMinorThreshold parameter.  
		</p><div class="example"><a name="id293507"></a><p class="title"><b>Example 1.2. Setting the <code class="varname">MsgQueueMinorThreshold</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("snmpstats", "MsgQueueMinorThreshold", 2000)
...
		</pre></div></div><br class="example-break"><p>
		If this parameter is not set, then there will be no minor alarm monitoring.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293526"></a>1.4.3. <code class="varname">MsgQueueMajorThreshold</code> (Integer)</h3></div></div></div><p>
		The SNMPStats module monitors the number of bytes waiting to be consumed by 
		OpenSIPS.  If the number of bytes waiting to be consumed exceeds a major
		threshold, the SNMPStats module will send out an openserMsgQueueDepthMajorEvent
		trap to signal that an alarm condition has occured.  The major threshold is set
		with the MsgQueueMajorThreshold parameter.  
		</p><div class="example"><a name="id293540"></a><p class="title"><b>Example 1.3. Setting the <code class="varname">MsgQueueMajorThreshold</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("snmpstats", "MsgQueueMajorThreshold", 5000)
...
		</pre></div></div><br class="example-break"><p>
		If this parameter is not set, then there will be no major alarm monitoring.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293559"></a>1.4.4. <code class="varname">dlg_minor_threshold</code> (Integer)</h3></div></div></div><p>
		The SNMPStats module monitors the number of active dialogs.  If the number of
		active dialogs exceeds a minor threshold, the SNMPStats module will send out 
		an openserDialogLimitMinorEvent trap to signal that an alarm condition has 
		occured.  The minor threshold is set with the dlg_minor_threshold parameter.  
		</p><div class="example"><a name="id293573"></a><p class="title"><b>Example 1.4. Setting the <code class="varname">dlg_minor_threshold</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
  modparam("snmpstats", "dlg_minor_threshold", 500)
...
		</pre></div></div><br class="example-break"><p>
		If this parameter is not set, then there will be no minor alarm monitoring.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293593"></a>1.4.5. <code class="varname">dlg_major_threshold</code> (Integer)</h3></div></div></div><p>
		The SNMPStats module monitors the number of active dialogs.  If the number of
		active dialogs exceeds a major threshold, the SNMPStats module will send out 
		an openserDialogLimitMajorEvent trap to signal that an alarm condition has 
		occured.  The major threshold is set with the dlg_major_threshold parameter.  
		</p><div class="example"><a name="id293606"></a><p class="title"><b>Example 1.5. Setting the <code class="varname">dlg_major_threshold</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
  modparam("snmpstats", "dlg_major_threshold", 750)
...
		</pre></div></div><br class="example-break"><p>
		If this parameter is not set, then there will be no major alarm monitoring.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293627"></a>1.4.6. <code class="varname">snmpgetPath</code> (String)</h3></div></div></div><p>
		The SNMPStats module provides the openserSIPServiceStartTime scalar.
		This scalar requires the SNMPStats module to perform a snmpget query
		to the master agent.  You can use this parameter to set the path to 
		your instance of NetSNMP's snmpget program.  
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">/usr/local/bin/</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id293649"></a><p class="title"><b>Example 1.6. Setting the <code class="varname">snmpgetPath</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("snmpstats", "snmpgetPath",     "/my/custom/path/")
...
		</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293666"></a>1.4.7. <code class="varname">snmpCommunity</code> (String)</h3></div></div></div><p>
		The SNMPStats module provides the openserSIPServiceStartTime scalar.
		This scalar requires the SNMPStats module to perform a snmpget query
		to the master agent.  If you have defined a custom community string
		for the snmp daemon, you need to specify it with this parameter.  
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">public</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id293689"></a><p class="title"><b>Example 1.7. Setting the <code class="varname">snmpCommunity</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("snmpstats", "snmpCommunity", "customCommunityString")
...
		</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293707"></a>1.5. Exported Functions</h2></div></div></div><p>
		Currently, there are no exported functions.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293716"></a>1.6. Installation and Running</h2></div></div></div><p>
	There are several things that need to be done to get the SNMPStats module
	compiled and up and running.
	</p><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293726"></a>1.6.1. 
	Compiling the SNMPStats Module
	</h3></div></div></div><p>
	In order for the SNMPStats module to compile, you will need at least version
	5.3 of the NetSNMP source code.  The source can be found at:

	</p><pre class="programlisting">
    http://net-snmp.sourceforge.net/ 
	</pre><p>

	For the specifics of installing NetSNMP, please see the INSTALL document in the
	root of the NetSNMP source package.  
	</p><p>
	The SNMPStats modules makefile requires that the NetSNMP script
	"net-snmp-config" can run.  At a minimum, running "net-snmp-config --agent-libs"
	from the OpenSIPS source directory should return something similar to: 

	</p><pre class="programlisting">
    -L/usr/local/lib -lnetsnmpmibs -lnetsnmpagent -lnetsnmphelpers -lnetsnmp
	</pre><p>

	The specifics of what is returned depends on how the system was configured. If
	your NetSNMP installation was installed from an RPM (or another packaged
	version), then there is a good chance that net-snmp-config will return
	something unecessarily longer.  It is highly recommended you install NetSNMP
	from source to avoid bringing in excessive dependencies to the SNMPStats
	module.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293758"></a>1.6.2. 
	Configuring NetSNMP to allow connections from the SNMPStats module.
	</h3></div></div></div><p>
	The SNMPStats module will communicate with the NetSNMP Master Agent.  This 
	communication happens over a protocol known as AgentX. This means that NetSNMP
	must have been compiled with AgentX support.  This will always be the case when
	you are compiling from source unless you explicitly removed AgentX support with
	./configure.  
	</p><p>
	After AgentX support has been compiled into NetSNMP, its configuration file needs
	to be changed to turn on AgentX support.  The exact location of the configuration 
	file (snmpd.conf) may vary depending on your system.  On my system, it is located in:
 
	</p><pre class="programlisting">
    /usr/local/share/snmp/snmpd.conf.
    	</pre><p>

	At the very end of the file add the following line:

	</p><pre class="programlisting">
    master agentx
	</pre><p>

	The line tells NetSNMP to act as an AgentX master agent, so that it can accept
	connections from sub-agents such as the SNMPStats module.  
	</p><p>
	There is still one last step.  Even though we have compiled and configured NetSNMP
	to have AgentX support, we still need to tell the daemon which interface and 
	port to listen to for AgentX connections. This is done when the daemon is started
	as follows:

	</p><pre class="programlisting">
    snmpd -x mySystemName:PortNumber
	</pre><p>

	On my system, I start the NetSNMP daemon with:

	</p><pre class="programlisting">
    snmpd -x localhost:705
	</pre><p>

	This tells NetSNMP to act as a master agent, listening on the localhost UDP
	interface at port 705.  
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293806"></a>1.6.3. 
	Configuring the SNMPStats module for communication with a Master Agent
	</h3></div></div></div><p>
	The previous section explained how to set up a NetSNMP master agent to accept
	AgentX connections.  We now need to tell the SNMPStats module how to communicate
	with this master agent.  This is done by giving the SNMPStats module its own
	NetSNMP configuration file.  The file must be named snmpstats.conf, and must be
	in the same folder as the snmpd.conf file that was configured above. On my 
	system this would be:

	</p><pre class="programlisting">
    /usr/local/share/snmp/snmpstats.conf
	</pre><p>

	The default configuration file included with the distribution can be used, and
	contains the following:

	</p><pre class="programlisting">
    agentXSocket tcp:localhost:705
	</pre><p>

	The above line tells the SNMPStats module to register with the master agent on
	the localhost, port 705.  The parameters should match up with the snmpd process.
	Note that the master agent (snmpd) does not need to be present on the same
	machine as OpenSIPS.  localhost could be replaced with any other machine. 
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293834"></a>1.6.4. 
	Testing for a proper Configuration
	</h3></div></div></div><p>
	As a quick test to make sure that the SNMPStats module sub-agent can succesfully
	connect to the NetSNMP Master agent, start snmpd with the following:

	</p><pre class="programlisting">
    snmpd -f -Dagentx -x tcp:localhost:705 2&gt;&amp;1 | less
	</pre><p>

	You should see something similar to the following:

	</p><pre class="programlisting">
    No log handling enabled - turning on stderr logging
    registered debug token agentx, 1
    ...
    Turning on AgentX master support.
    agentx/master: initializing...
    agentx/master: initializing...   DONE
    NET-SNMP version 5.3.1
	</pre><p>

	Now, start up OpenSIPS in another window.  In the snmpd window, you should see a
	bunch of:

	</p><pre class="programlisting">
    agentx/master: handle pdu (req=0x2c58ebd4,trans=0x0,sess=0x0)
    agentx/master: open 0x81137c0
    agentx/master: opened 0x814bbe0 = 6 with flags = a0
    agentx/master: send response, stat 0 (req=0x2c58ebd4,trans=0x0,sess=0x0)
    agentx_build: packet built okay
	</pre><p>

	The messages beginning with "agentx" are debug messages stating that something is happening
	with an AgentX sub-agent, appearing because of the -Dagentx snmpd switch.  The large number
	of debug messages appear at startup as the SNMPStats module registers all of its scalars
	and tables with the Master Agent.  If you receive these messages, then SNMPStats module
	and NetSNMP daemon have both been configured correctly.
	</p></div></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id294628"></a>Chapter 2. Frequently Asked Questions</h2></div></div></div><div class="qandaset"><table border="0" summary="Q and A Set"><col align="left" width="1%"><tbody><tr class="question"><td align="left" valign="top"><a name="id294632"></a><a name="id294315"></a><p><b>2.1.</b></p></td><td align="left" valign="top"><p>Where can I find more about SNMP?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			There are many websites that explain SNMP at all levels of detail.
			A great general introduction can be found at http://en.wikipedia.org/wiki/SNMP

			If you are interested in the nitty gritty details of the protocol, 
			then please look at RFC 3410.  RFC 3410 maps out the many other RFCs
			that define SNMP, and can be found at http://www.rfc-archive.org/getrfc.php?rfc=3410
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id294642"></a><a name="id294645"></a><p><b>2.2.</b></p></td><td align="left" valign="top"><p>Where can I find more about NetSNMP?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			NetSNMP source code, documentation, FAQs, and tutorials can all be found at
			http://net-snmp.sourceforge.net/.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id294660"></a><a name="id294662"></a><p><b>2.3.</b></p></td><td align="left" valign="top"><p>Where can I find out more about AgentX?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			The full details of the AgentX protocol are explained in RFC 2741, 
			available at: http://www.rfc-archive.org/getrfc.php?rfc=2741
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id294677"></a><a name="id294679"></a><p><b>2.4.</b></p></td><td align="left" valign="top"><p>Why am I not receiving any SNMP Traps?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
		Assuming you've configured the trap thresholds in opensips.cfg with something similar to:
		</p><pre class="programlisting">
    modparam("snmpstats", "MsgQueueMinorThreshold", 1234)
    modparam("snmpstats", "MsgQueueMajorThreshold", 5678)

    modparam("snmpstats", "dlg_minor_threshold", 500)
    modparam("snmpstats", "dlg_minor_threshold", 600)
		</pre><p>
		Then either OpenSIPS is not reaching these thresholds (which is a good thing),
		or you haven't set up the trap monitor correctly.  To prove this to yourself,
		you can start NetSNMP with:
		</p><pre class="programlisting">
    snmpd -f -Dtrap -x localhost:705
		</pre><p>
		The -f tells the NetSNMP process to not daemonize, and the -Dtrap enables trap
		debug logs.  You should see something similar to the following: 
		</p><pre class="programlisting">
    registered debug token trap, 1
    trap: adding callback trap sink            ----- You should see both
    trapsess: adding to trap table             ----- of these lines.
    Turning on AgentX master support.
    trap: send_trap 0 0 NET-SNMP-TC::linux
    trap: sending trap type=167, version=1
    NET-SNMP version 5.3.1
		</pre><p>
		If the two lines above did not appear, then you probably have not included
		the following in your snmpd.conf file.
		</p><pre class="programlisting">
    trap2sink machineToSendTrapsTo:machinesPortNumber.
		</pre><p>
		When a trap has been received by snmpd, the following will appear in the
		above output:
		</p><pre class="programlisting">
    sent_trap -1 -1 NET-SNMP-TC::linus
    sending trap type=167, version=1
		</pre><p>
		You'll also need a program to collect the traps and do something with them
		(such as sending them to syslog).  NetSNMP provides snmptrapd for this.  Other
		solutions exist as well.  Google is your friend.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id294748"></a><a name="id294750"></a><p><b>2.5.</b></p></td><td align="left" valign="top"><p>OpenSIPS refuses to load the SNMPStats module.  Why is it displaying "load_module: could not open module snmpstats.so"?
		</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
		On some systems, you may receive the following error at stdout or the log files
		depending on the configuration.  
		</p><pre class="programlisting">
    ERROR: load_module: could not open module &lt;/usr/local/lib/opensips/modules/snmpstats.so&gt;: 
           libnetsnmpmibs.so.10: cannot open shared object file: No such file or directory.
		</pre><p>	
		This means one of two things:
		</p><div class="orderedlist"><ol type="1"><li><p>
				You did not install NetSNMP.  ("make install" if building from source)
				</p></li><li><p>
				The dynamic linker cannot find the necessary libraries.  
				</p></li></ol></div><p>	
		In the second case, the fix is as follows:
		</p><div class="orderedlist"><ol type="1"><li><p>
				find / -name "libnetsnmpmibs*"
				</p><div class="itemizedlist"><ul type="disc"><li><p>
			You will find a copy unless you haven't installed NetSNMP.
			Make note of the path.
						</p></li></ul></div><p>
				</p></li><li><p>
				less /etc/ld.so.conf
				</p><div class="itemizedlist"><ul type="disc"><li><p>
			If the file is missing the path from step 1, then add the path to
			ld.so.conf
						</p></li></ul></div><p>

				</p></li><li><p>
				ldconfig
				</p></li><li><p>
				Try starting OpenSIPS again.
				</p></li></ol></div><p>
		Alternatively, you may prefix your startup command with:
		</p><pre class="programlisting">
    LD_LIBRARY_PATH=/path/noted/in/step/one/above
		</pre><p>
		For example, on my system I ran:
		</p><pre class="programlisting">
    LD_LIBRARY_PATH=/usr/local/lib opensipsctl start
		</pre></td></tr><tr class="question"><td align="left" valign="top"><a name="id294880"></a><a name="id294882"></a><p><b>2.6.</b></p></td><td align="left" valign="top"><p>How can I learn what all the scalars and tables are?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
		All scalars and tables are named in the SNMPStats module overview.  The files
		OPENSER-MIB, OPENSER-REG-MIB, OPENSER-SIP-COMMON-MIB and OPENSER-SIP-SERVER-MIB
		contain the full definitions and descriptions.  Note however, that the MIBs
		may actually contain scalars and tables which are currently not provided by the
		SNMPStats module.  Therefore, it is better to use NetSNMP's snmptranslate
		as an alternative. Take the openserSIPEntityType scalar as an example. You can
		invoke snmptranslate as follows:

		</p><pre class="programlisting">
    snmptranslate -TBd openserSIPEntityType
		</pre><p>		

		Which would result in something similar to the following:

		</p><pre class="programlisting">
    -- FROM       OPENSER-SIP-COMMON-MIB
    -- TEXTUAL CONVENTION OpenSIPSSIPEntityRole
    SYNTAX        BITS {other(0), userAgent(1), proxyServer(2), redirectServer(3), registrarServer(4)} 
    MAX-ACCESS    read-only
    STATUS        current
    DESCRIPTION   " This object identifies the list of SIP entities this
                   row is related to. It is defined as a bit map.  Each
                   bit represents a type of SIP entity.
                   If a bit has value 1, the SIP entity represented by
                   this row plays the role of this entity type.
  
                   If a bit has value 0, the SIP entity represented by
                   this row does not act as this entity type
                   Combinations of bits can be set when the SIP entity
                   plays multiple SIP roles."
		</pre><p>  

		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id294919"></a><a name="id294921"></a><p><b>2.7.</b></p></td><td align="left" valign="top"><p>Why do snmpget, snmpwalk, and snmptable always time out?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
		If your snmp operations are always returning with: "Timeout: No Response
		from localhost", then chances are that you are making the query with the wrong
		community string.  Default installs will most likely use "public" as their
		default community strings. Grep your snmpd.conf file for the string 
		"rocommunity", and use the result as your community string in your queries.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id294558"></a><a name="id294560"></a><p><b>2.8.</b></p></td><td align="left" valign="top"><p>How do I use snmpget?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
		NetSNMP's snmpget is used as follows:

		</p><pre class="programlisting">
    snmpget -v 2c -c theCommunityString machineToSendTheMachineTo scalarElement.0
    		</pre><p>

		For example, consider an snmpget on the openserSIPEntityType scalar, 
		run on the same machine running the OpenSIPS instance, with the default
		"public" community string.  The command would be:

		</p><pre class="programlisting">
    snmpget -v2c -c public localhost openserSIPEntityType.0
		</pre><p>

		Which would result in something similar to:

		</p><pre class="programlisting">
    OPENSER-SIP-COMMON-MIB::openserSIPEntityType.0 = BITS: F8 \
		other(0) userAgent(1) proxyServer(2)          \
		redirectServer(3) registrarServer(4) 
		</pre><p>

		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id294596"></a><a name="id294598"></a><p><b>2.9.</b></p></td><td align="left" valign="top"><p>How do I use snmptable?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
		NetSNMP's snmptable is used as follows:

		</p><pre class="programlisting">
    snmptable -Ci -v 2c -c theCommunityString machineToSendTheMachineTo theTableName
    		</pre><p>

		For example, consider the openserSIPRegUserTable.  If we run the snmptable
		command on the same machine as the running OpenSIPS instance, configured with
		the default "public" community string.  The command would be:

		</p><pre class="programlisting">
    snmptable -Ci -v 2c -c public localhost openserSIPRegUserTable
		</pre><p>

		Which would result in something similar to:

		</p><pre class="programlisting">
    index openserSIPUserUri openserSIPUserAuthenticationFailures
        1       DefaultUser                                    0
        2            bogdan                                    0
        3    jeffrey.magder                                    0
		</pre><p>

		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id295083"></a><a name="id295085"></a><p><b>2.10.</b></p></td><td align="left" valign="top"><p>Where can I find more about OpenSIPS?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			Take a look at <a class="ulink" href="http://www.opensips.org/" target="_top">http://www.opensips.org/</a>.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id295112"></a><a name="id295114"></a><p><b>2.11.</b></p></td><td align="left" valign="top"><p>Where can I post a question about this module?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			First at all check if your question was already answered on one of
			our mailing lists: 
		</p><div class="itemizedlist"><ul type="disc"><li><p>User Mailing List - <a class="ulink" href="http://lists.opensips.org/cgi-bin/mailman/listinfo/users" target="_top">http://lists.opensips.org/cgi-bin/mailman/listinfo/users</a></p></li><li><p>Developer Mailing List - <a class="ulink" href="http://lists.opensips.org/cgi-bin/mailman/listinfo/devel" target="_top">http://lists.opensips.org/cgi-bin/mailman/listinfo/devel</a></p></li></ul></div><p>
			E-mails regarding any stable OpenSIPS release should be sent to 
			<code class="email">&lt;<a class="email" href="mailto:users@lists.opensips.org">users@lists.opensips.org</a>&gt;</code> and e-mails regarding development versions
			should be sent to <code class="email">&lt;<a class="email" href="mailto:devel@lists.opensips.org">devel@lists.opensips.org</a>&gt;</code>.
		</p><p>
			If you want to keep the mail private, send it to 
			<code class="email">&lt;<a class="email" href="mailto:users@lists.opensips.org">users@lists.opensips.org</a>&gt;</code>.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id295169"></a><a name="id295171"></a><p><b>2.12.</b></p></td><td align="left" valign="top"><p>How can I report a bug?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			Please follow the guidelines provided at:
			<a class="ulink" href="https://github.com/OpenSIPS/opensips/issues" target="_top">https://github.com/OpenSIPS/opensips/issues</a>.
		</p></td></tr></tbody></table></div></div></div></body></html>
